#!/bin/bash
#****b* Script/cron.sh
# NAME
#   cron.sh
#   Das Script sichert die Datenbanken im Verzeichnis /usr/share/uverein/log
# COPYRIGHT
#   (c) GPL by Uwe Schied
# AUTOR
#   Uwe Schied
# ERGEBNIS
#   Im Verzeichnis /usr/share/uverein/log wird eine Sicherungskopie
#   der Datenbanken
#     * udb.uverein            produktive Datenbank
#     * udb.version            Versionsverwaltung
#   angelegt
#
for DB in "udb.uverein" "udb.version" ; do
  TEST=$(psql -f /usr/share/uverein/bash/cron.input template1 | grep -w "${DB}")
  if [ -n "${TEST}" ]; then
    pg_dump --create \
            --column-inserts \
             "${DB}" \
    | gzip -9 > /usr/share/uverein/log/$(date +%w)-${DB}.gz
  fi
done

#***
