<?php

//****h* Datensicherung/0.2.1.save.php
// NAME
//   0.2.1.save.php
// GENUTZT VON
//   allen Versionen >= 0.2.1
//                    < 0.2.3-1 
// BESCHREIBUNG
//   Folgende Daten werden gesichert:

include_once "base.inc";
include_once "klassen/tabdatei.inc";
include_once "header.inc";

$F_ilename = "uverein-" . $VEREIN_NAME . ".gz";
$F_ile = gzopen ("/tmp/".$F_ilename,"w9");

function _w    ($S) { global $F_ile; gzwrite ($F_ile,"$S"); }
function _wno ($S) { _w ($S);         }
function _wnl ($S) { _w ($S . " \n"); }

//
//   1. Vereinsdaten
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM vereine WHERE kurzname='$VEREIN_NAME'");
$data = $UVEREIN_DB->sql_line (0,$qu);
//      * Name des Vereins
_wnl ("-- --------------------------------------------------------");
_wnl ("-- " . $data->name);
_wnl ("-- " . $data->kurzname);
_wnl ("-- erstellt am " . date("d.m.Y"));
_wnl ("-- --------------------------------------------------------");
//      * Vereinsdaten fuer die Tabelle vereine
_wno ("INSERT INTO vereine (name,kurzname,strasse,ort,blz,bank,kontonr,email) ");
_wno ("VALUES (");
_wno ("'" . $data->name . "'");
_wno (",'" . $data->kurzname . "'");
_wno (",'" . $data->strasse . "'");
_wno (",'" . $data->ort . "'");
_wno (",'" . $data->blz . "'");
_wno (",'" . $data->bank . "'");
_wno (",'" . $data->kontonr . "'");
_wno (",'" . $data->email . "'");
_wnl (");");
//      * CREATE Vereins-Tabellen
_wnl ("CREATE TABLE $VEREIN_NAME (".
        "nr INT8 DEFAULT 1 NOT NULL UNIQUE REFERENCES personen (nr)".
      ", eintritt DATE NOT NULL".
      ", ende DATE".
      ", kommentar TEXT".
      ", zahlungsart SMALLINT DEFAULT 1 NOT NULL REFERENCES key_zahlungsarten  (nr)".
      ")");
$E_name = $VEREIN_NAME . "_einzug";
_wnl ("CREATE TABLE $E_name (".
      "  nr INT8 DEFAULT 1 NOT NULL UNIQUE REFERENCES $VEREIN_NAME (nr)".
      ", blz NUMERIC (8,0) NOT NULL REFERENCES key_banken (blz)".
      ", konto NUMERIC (10,0) NOT NULL".
      ")");

//
//   2. Buchhaltung
//      * Buchungsklassen
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM bu_klassen WHERE verein='$VEREIN_NAME'");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: bu_klassen ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO bu_klassen (verein,kl_nr,kl_name)".
        " VALUES ('$VEREIN_NAME','".$data->kl_nr."',".
                 "'".$data->kl_name."');");
  $i++;
}
//      * Buchungskonten
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM bu_konten WHERE verein='$VEREIN_NAME'");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: bu_konten ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO bu_konten".
        " (verein,kto_nr,kto_name,kto_klasse,kto_ziel,kto_stand)".
        " VALUES ('$VEREIN_NAME','".$data->kto_nr."'".
                 ",'".$data->kto_name."'".
                 ",'".$data->kto_klasse."'".
                 ",'".$data->kto_ziel."'".
                 ",'".$data->kto_stand."');");
  $i++;
}
//      * Kostenstellen
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM bu_kst WHERE verein='$VEREIN_NAME'");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: bu_kst ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO bu_kst (verein,kst,kst_name)".
        " VALUES ('$VEREIN_NAME','".$data->kst."'".
                 ",'".$data->kst_name."');");
  $i++;
}
//      * Buchungsbelege
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM bu_belege WHERE b_verein='$VEREIN_NAME'");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: bu_belege ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("DELETE FROM bu_belege".
        " WHERE idx='".$data->idx."' AND b_verein='$VEREIN_NAME';");
  _wnl ("INSERT INTO bu_belege (b_verein,b_nr,b_jahr,b_datum,b_konto,".
                               "f_konto,b_betrag,b_steuer,b_text,b_kst)".
        " VALUES ('$VEREIN_NAME','".$data->b_nr."'".
                 ",'".$data->b_jahr."'".
                 ",'".$data->b_datum."'".
                 ",'".$data->b_konto."'".
                 ",'".$data->f_konto."'".
                 ",'".$data->b_betrag."'".
                 ",'".$data->b_steuer."'".
                 ",'".$data->b_text."'".
                 ",'".$data->b_kst."');");
  $i++;
}
//      * Bilanz-Daten
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM bilanz WHERE verein='$VEREIN_NAME'");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: bilanz ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO bilanz (verein,jahr,summe,waehrung,schlusstxt,prueftxt,datum) " .
        " VALUES ('$VEREIN_NAME','".$data->jahr."'".
                 ",'".$data->summe."'".
                 ",'".$data->waehrung."'".
                 ",'".$data->schlusstxt."'".
                 ",'".$data->prueftxt."'".
                 ",'".$data->datum."');");
  $i++;
}

//
//   3. Allgemeine Daten fuer die Mitgliederverwaltung
//      * Anrede-Schluessel
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM key_anrede");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: key_anrede ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO key_anrede VALUES (".
        "'".$data->schluessel."'".
        ",'".$data->brief."'".
        ",'".$data->inhalt."');");
  $i++;
}
//      * Zahlungsarten
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM key_zahlungsarten");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: key_zahlungsarten ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO key_zahlungsarten VALUES (".
        "'".$data->nr."'".
        ",'".$data->bezeichnung."');");
  $i++;
}
//      * Banken mit Bankleitzahl
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM key_banken");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: key_banken ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO key_banken VALUES (".
        "'".$data->blz."'".
        ",'".$data->bank."');");
  $i++;
}
//      * Zahlungsweise
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM zahlungsweise");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: zahlungsweise ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO zahlungsweise VALUES (".
        "'".$data->nr."'".
        ",'".$data->art."'".
        ",'".$data->einmalig."'".
        ",'".$data->teiler."');");
  $i++;
}
//      * Beitragsarten
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM beitrags_art WHERE verein='$VEREIN_NAME'");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: beitrags_art ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO beitrags_art VALUES (".
        "'".$data->nr."'".
        ",'$VEREIN_NAME'".
        ",'".$data->art."'".
        ",'".$data->jahresbeitrag."');");
  $i++;
}
//      * Sonderangaben aus virtual_konto
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM virtual_konto WHERE verein='$VEREIN_NAME'");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: virtual_konto ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO virtual_konto VALUES (".
        "'$VEREIN_NAME'".
        ",'".$data->art."'".
        ",'".$data->konto."'".
        ",'".$data->fkonto."'".
        ",'".$data->kst."');");
  $i++;
}
//      * Standard-Briefe
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM briefe WHERE verein='$VEREIN_NAME'");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: briefe ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO briefe VALUES (".
        "'$VEREIN_NAME'".
        ",'".$data->nr."'".
        ",'".$data->info."'".
        ",'".$data->inhalt."');");
  $i++;
}
//
//   4. Steuer-Berechnung
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM tax_base WHERE verein='$VEREIN_NAME'");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: tax_base ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO tax_base VALUES (".
        "'$VEREIN_NAME'".
        ",'".$data->nr."'".
        ",'".$data->steuersatz."');");
  $i++;
}
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM tax_konten WHERE verein='$VEREIN_NAME'");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: tax_konten ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO tax_konten VALUES (".
        "'$VEREIN_NAME'".
        ",'".$data->steuersatz."'".
        ",'".$data->kto."');");
  $i++;
}
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM tax WHERE verein='$VEREIN_NAME'");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: tax ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO tax VALUES (".
        "'$VEREIN_NAME'".
        ",'".$data->jahr."'".
        ",'".$data->datum."'".
        ",'".$data->art."'".
        ",'".$data->umsatz."'".
        ",'".$data->steuer."');");
  $i++;
}

//
//   5. Mitgliederverwaltung
function personen_where ($nr)
{
  global $UVEREIN_DB;
  $abfrage = $UVEREIN_DB->sql_befehl ("SELECT * FROM personen WHERE nr='$nr'");
  $d = $UVEREIN_DB->sql_line (0,$abfrage);
  $ret = " FROM personen WHERE".
             " name='".$d->name."'".
         " AND vorname='".$d->vorname."'".
         " AND geboren='".$d->geboren."'".
         " AND plz='".$d->plz."'".
         " AND ort='".$d->ort."'".
         " AND email='".$d->email."'".
         ";";
  return ($ret);
}
//      * Personen-Tabelle und Vereinstabelle
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM $VEREIN_NAME");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: personen");
_wnl ("-- TABLE: $VEREIN_NAME ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  $pqu = $UVEREIN_DB->sql_befehl ("SELECT * FROM personen WHERE nr='".$data->nr."'");
  $pdta = $UVEREIN_DB->sql_line (0,$pqu);
  _wnl ("INSERT INTO personen ".
        "(anrede, titel, name, vorname, geboren, strasse, hausnr,".
	"land,plz,ort,telefon,email) VALUES (".
        "'".$pdta->anrede."'".
        ",'".$pdta->titel."'".
        ",'".$pdta->name."'".
        ",'".$pdta->vorname."'".
        ",'".$pdta->geboren."'".
        ",'".$pdta->strasse."'".
        ",'".$pdta->hausnr."'".
        ",'".$pdta->land."'".
        ",'".$pdta->plz."'".
        ",'".$pdta->ort."'".
        ",'".$pdta->telefon."'".
        ",'".$pdta->email."');");
  if (empty ($data->ende))
  {
    _wnl ("INSERT INTO $VEREIN_NAME (nr,eintritt,kommentar,zahlungsart)".
          " SELECT nr,'".$data->eintritt."','".
            $data->kommentar."','".$data->zahlungsart."'" .
            personen_where ($data->nr));
  }
  else
  {
    _wnl ("INSERT INTO $VEREIN_NAME (nr,eintritt,ende,kommentar,zahlungsart)".
          " SELECT nr,'".$data->eintritt."','".$data->ende."','".
            $data->kommentar."','".$data->zahlungsart."'" .
            personen_where ($data->nr));
  }
  $i++;
}
//      * Einzugsermaechtigungen
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM $E_name");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: $E_name ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO $E_name (nr,blz,konto)".
          " SELECT nr,'".$data->blz."','".$data->konto."'".
            personen_where ($data->nr));
  $i++;
}
//      * Beitragsbuchungen
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM beitrag WHERE v_name='$VEREIN_NAME'");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: beitrag ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO beitrag (bu_nr,v_name,m_nr,jahr,f_konto,".
        "datum,soll,haben,bu_text)".
        " SELECT '".$data->bu_nr."','$VEREIN_NAME',nr,'".
                    $data->jahr."','".$data->f_konto."','".
                    $data->datum."','".$data->soll."','".
                    $data->haben."','".$data->bu_text."'".
          personen_where ($data->m_nr));
  $i++;
}
//      * Informationen zur Beitragszahlung
$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM beitrags_konto WHERE v_name='$VEREIN_NAME'");
$anz = $UVEREIN_DB->sql_lines ($qu);
_wnl ("-- ");
_wnl ("-- TABLE: beitrags_konto ($anz rows)");
_wnl ("-- ");
$i = 0; while ($i < $anz)
{
  $data = $UVEREIN_DB->sql_line ($i,$qu);
  _wnl ("INSERT INTO beitrags_konto (nr,v_name,m_nr,faellig_ab,".
        "art,zahlungsweise)".
        " SELECT '".$data->nr."','$VEREIN_NAME',nr,'".
                    $data->faellig_ab."','".$data->art."','".
                    $data->zahlungsweise."'".
          personen_where ($data->m_nr));
  $i++;
}

gzclose ($F_ile);

header ("Content-Type: application/octet-stream");
header ("Content-Disposition: attachment; filename=\"$F_ilename\"");

readfile ("/tmp/".$F_ilename);

//****
?>
