<?php

//****h* Datensicherung/__save__.php
// NAME
//   __save__.php
// GENUTZT VON
//   allen Versionen >= 0.2.3-1
// BESCHREIBUNG
//   Erstellt eine mit bzip komprimierte Datei mit den aktuellen Daten
//   zum aktiven Verein und stellt die Datei zum Download im Browser
//   bereit.
// HISTORIE
//   07.02.2009     Start mit Version 0.2.3-1
//***

include_once "base.inc";
include_once "header.inc";

// --------------------------------------------------------
// Datei im temoraeren Ordner des Servers erstellen
// --------------------------------------------------------
$F_ilename = "uverein-" . $VEREIN_NAME . ".bz2";
$F_ile = bzopen ("/tmp/".$F_ilename,"w");

// --------------------------------------------------------
// Daten in Datei schreiben
// _w      wird von den folgenden Funktionen benoetigt
// _wno    ohne Zeilenumbruch
// _wnl    mit Zeilenumbruch
// --------------------------------------------------------
function _w    ($S) { global $F_ile; bzwrite ($F_ile,"$S"); }
function _wno ($S) { _w ($S);         }
function _wnl ($S) { _w ($S . " \n"); }

function write_table ($name, $SELECT)
{
  global $UVEREIN_DB;
  $UVEREIN_DB->sql_befehl ($SELECT);
  $zeilen  = $UVEREIN_DB->sql_lines();
  $SPALTE  = $UVEREIN_DB->fieldnames();
  $spalten = $UVEREIN_DB->sql_fields();
  _wnl ($name . "\t" . $zeilen);
  $i = 0; while ($i < $zeilen)
  {
     $data = $UVEREIN_DB->sql_line($i); $i++;
     $e = 1; reset ($SPALTE); foreach ($SPALTE as $key => $feld)
     {
        if ($e == $spalten) _wnl ($data->$feld);
        else                _wno ($data->$feld."\t");
        $e++;
     }
  }
}
function write_norm ($name,$feld)
{
  global $VEREIN_NAME;
  write_table ($name,"SELECT * FROM $name WHERE $feld='$VEREIN_NAME'");
}

// --------------------------------------------------------
// Programm-Version sichern, damit Restore klappt
// --------------------------------------------------------
$ARR = explode ("R", $PROGRAM_VERSION);
_wnl ($ARR[0]);

// --------------------------------------------------------
// Kurzname des Vereins
// --------------------------------------------------------
_wnl ($VEREIN_NAME);

// --------------------------------------------------------
// key_anrede               Anredeschluessel
// --------------------------------------------------------
write_table ("key_anrede","SELECT * FROM key_anrede");
// --------------------------------------------------------
// key_banken               Bankleitzahlen mit Banknamen
// --------------------------------------------------------
write_table ("key_banken","SELECT * FROM key_banken");
// --------------------------------------------------------
// key_zahlungsarten        Zahlungsarten fuer alle Vereine
// --------------------------------------------------------
write_table ("key_zahlungsarten","SELECT * FROM key_zahlungsarten");
// --------------------------------------------------------
// zahlungsweise            Zahlungsweisen fuer alle
// --------------------------------------------------------
write_table ("zahlungsweise","SELECT * FROM zahlungsweise");
// --------------------------------------------------------
// personen                 Personendaten fuer alle Vereine
// --------------------------------------------------------
write_table ("personen",
             "SELECT * FROM personen, $VEREIN_NAME WHERE personen.nr=$VEREIN_NAME.nr");
// --------------------------------------------------------
// vereine                  Daten zum Verein
// --------------------------------------------------------
write_norm ("vereine","kurzname");
// --------------------------------------------------------
// VEREIN                   Mitgliederdaten zum Verein
// --------------------------------------------------------
write_table ($VEREIN_NAME,"SELECT * FROM $VEREIN_NAME");
// --------------------------------------------------------
// EINZUGSERMAECHTIGUNG     Einzugsermaechtigungen
// --------------------------------------------------------
write_table ($VEREIN_NAME."_einzug","SELECT * FROM $VEREIN_NAME"."_einzug");
// --------------------------------------------------------
// opt_tabledef             Sonstige optionle Felder
// --------------------------------------------------------
write_norm ("opt_tabledef","verein");
// --------------------------------------------------------
// opt_tabledata            Daten zu optionalen Feldern
// --------------------------------------------------------
write_table ("opt_tabledata",
             "SELECT opt_table, person, inhalt FROM opt_tabledef opt_tabledef
              WHERE opt_table=nr");
// --------------------------------------------------------
// beitrag                  Beitrags-Konto
// --------------------------------------------------------
write_norm ("beitrag","v_name");
// --------------------------------------------------------
// beitrags_art             Beitragsarten
// --------------------------------------------------------
write_norm ("beitrags_art","verein");
// --------------------------------------------------------
// beitrags_konto           Beitragsfaelligkeitn
// --------------------------------------------------------
write_norm ("beitrags_konto","v_name");
// --------------------------------------------------------
// bilanz                   Daten zum Jahresabschluss
// --------------------------------------------------------
write_norm ("bilanz","verein");
// --------------------------------------------------------
// bu_klassen               Kontenbereiche
// --------------------------------------------------------
write_norm ("bu_klassen","verein");
// --------------------------------------------------------
// bu_konten                Buchungskonten
// --------------------------------------------------------
write_norm ("bu_konten","verein");
// --------------------------------------------------------
// bu_kst                   Kostenstellen
// --------------------------------------------------------
write_norm ("bu_kst","verein");
// --------------------------------------------------------
// bu_belege                Buchungsbelege
// --------------------------------------------------------
write_norm ("bu_belege","b_verein");
// --------------------------------------------------------
// tax_base                 Steuer-Arten
// --------------------------------------------------------
write_norm ("tax_base","verein");
// --------------------------------------------------------
// tax_konten               steuerliche Zuordnung der Buchungskonten
// --------------------------------------------------------
write_norm ("tax_konten","verein");
// --------------------------------------------------------
// tax                      Daten zur Steuererklaerung
// --------------------------------------------------------
write_norm ("tax","verein");
// --------------------------------------------------------
// briefe                   Brieftexte
// --------------------------------------------------------
write_norm ("briefe","verein");
// --------------------------------------------------------
// virtual_konto            vereinsinterne Zuordnungen
// --------------------------------------------------------
write_norm ("virtual_konto","verein");
// --------------------------------------------------------
// Datei schliesen
// --------------------------------------------------------
bzclose ($F_ile);

// --------------------------------------------------------
// Zum Download auf dem Server bereitstellen
// --------------------------------------------------------
header ("Content-Type: application/octet-stream");
header ("Content-Disposition: attachment; filename=\"$F_ilename\"");
readfile ("/tmp/".$F_ilename);

?>
