<?php
//****h* Beitrag/beitrag-soll.php
// INFO
//   Automatische Eintragung des Beitrags-Solls
// HISTORIE
//   13.02.2010 von Test in Produktion uebertragen
//   18.01.2015 Faelligkeit an SEPA angepasst = heute + 9 Tage
// BUGS
//   keine bekannt

// ABHAENGIG VON
// SOURCE
include_once "base.inc";
include_once "header.inc";
include_once "klassen/uverein-database.inc";

// FUNCTION
echo page_head (i4l("DATA_BEITRAGSOLL"));
//   auswerten
//     Die Funktion ermittelt ob der Beitrag faellig ist und 
//     bucht ggf. das Beitrags-Soll
// BESCHREIBUNG
function auswerten ($LAST,$dat)
{
  global $UVEREIN_DB;
//   -> aktuelles Datum holen  
  $SOLLDATUM = date("Ymd",strtotime('+9 day'))*1;
//   -> Zahlungsweise ermitteln
  switch ($dat->zahlungsweise)
  {
    case 0 : // einmalig
      $MONATE = 1000; $TEILER = 1; break;
    case 1 : // jaehrlich
      $MONATE = 12; $TEILER = 1; break;
    case 2 : // halbjaehrlich
      $MONATE = 6; $TEILER = 2; break;
    case 3 : // monatlich
      $MONATE = 1; $TEILER = 12; break;
    case 4 : // vierteljaehrlich
      $MONATE = 3; $TEILER = 4; break;
    default : // unbekannt = jaehrlich
      $MONATE = 12; $TEILER = 1; break;
  }
//   -> Beitrag entsprechend der Zahlungsweise berechnen
  $BEITRAG = round ($UVEREIN_DB->get_beitragshoehe($dat->art)/$TEILER,2);
//   -> Buchungstext ermitteln
  $T_EXT = $UVEREIN_DB->get_beitragstext($dat->art); 
  $FAELLIG = $UVEREIN_DB->get_beitragfaellig($dat->nr);
  $TAG = $FAELLIG["TAG"]; $MONAT = $FAELLIG["MONAT"]; $JAHR = $FAELLIG["JAHR"];
  $TERMIN = ($JAHR*10000) + ($MONAT*100) + $TAG;
  while ($TERMIN <= $SOLLDATUM)
  {
//   -> Wenn der Beitrag faellig ist, buchen
    if ($TERMIN > $LAST)
    {
      $UVEREIN_DB->beitrag_insert 
      ($dat->m_nr, "$TAG.$MONAT.$JAHR", $T_EXT, 0, $BEITRAG);
    }
    $MONAT += $MONATE; while ($MONAT > 12) {$MONAT -= 12; $JAHR++; }
    $TERMIN = ($JAHR*10000) + ($MONAT*100) + $TAG;
  }
}

// FUNCTION
//   Hauptteil
// BESCHREIBUNG
//   -> Wann wurde das letzte Beitrags-Soll gebucht?
$LASTDATUM = $UVEREIN_DB->get_vsollbeitrag();
if ($LASTDATUM == 0) $LASTDATUM = date("Ymd",mktime(0,0,0,12,31,date("Y")-1));
//   -> Alle Eintraege aus der Tabelle 'beitrags_konto' auslesen
$qu = $UVEREIN_DB->sql_befehl 
      ("SELECT * FROM beitrags_konto".
       " WHERE v_name='".$UVEREIN_DB->get_verein()  ."'".
       "   AND faellig_ab<='".date("d.m.Y",strtotime('+9 day'))."'");
$SOLLDATUM = date("Ymd",strtotime('+9 day'))*1;
$i = 0; while ($i < $UVEREIN_DB->sql_lines($qu))
{
  $data = $UVEREIN_DB->sql_line($i,$qu); $i++;
//   -> Funktion 'auswerten' nur aufrufen, wenn der Betrag <> 0
  if ($UVEREIN_DB->get_beitragshoehe($data->art) > 0)
  {
    auswerten (($LASTDATUM * 1),$data);
  }
}
//   -> Buchung des Beitrags-Solls merken
$UVEREIN_DB->set_vsollbeitrag();

//   -> Info ausgeben
echo "<BR><BR><BR><H1>".i4l("BEITRAGSOLL_GEBUCHT")."</h1>";
echo "<BR><HR><H2>".substr($LASTDATUM,6,2).".".substr($LASTDATUM,4,2).".".substr($LASTDATUM,0,4);
echo " - ".substr($SOLLDATUM,6,2).".".substr($SOLLDATUM,4,2).".".substr($SOLLDATUM,0,4)."</H2><HR>";
echo page_ende();
//****
?> 