<?php

include_once "base.inc";

// ------------------------------------------------------------------
// Formular-Eintraege
// ------------------------------------------------------------------
function form_eintrag ($bezeichnung, $name, $vorgabe = NULL)
{
  global $FORM;
  $FORM->inhalt ("<TR><TD>".i4l($bezeichnung)."</td><TD>");
  $FORM->eingabe ($name,100,(($vorgabe == NULL) ? "" : $vorgabe));
  $FORM->inhalt ("</TD></TR>");
}

// ------------------------------------------------------------------
// Selektion aus Datenbank fuellen
// ------------------------------------------------------------------
function form_sel ($bezeichnung,$selname,$tabele, $selection,$order,$key,$name,$sel = NULL)
{
  global $FORM, $UVEREIN_DB;
  $UVEREIN_DB->sql_befehl ("SELECT * FROM $tabele WHERE $selection ORDER BY $order");
   $i = 0; $maxi = $UVEREIN_DB->sql_lines(); while ($i < $maxi)
   {
     $data = $UVEREIN_DB->sql_line ($i);
     $SEL[$data->$key] = $data->$name;
     $i++;
   }
   $FORM->inhalt ("<TR><TD>".i4l("$bezeichnung")."</td><TD>");
   $FORM->selection ($selname,$SEL,$sel);
   $FORM->inhalt ("</TD></TR>");   
}

// ------------------------------------------------------------------
// Selektion aus Array fuellen
// ------------------------------------------------------------------
function array_sel ($bezeichnung,$selname,$SEL,$sel = NULL)
{
  global $FORM;
  $FORM->inhalt ("<TR><TD>".i4l("$bezeichnung")."</td><TD>");
  $FORM->selection ($selname,$SEL,$sel);
  $FORM->inhalt ("</TD></TR>");   
}

// ------------------------------------------------------------------
// Ausgabezeile zusammensetzen
// ------------------------------------------------------------------
function pdf_aus ($bezeichnung,$inhalt)
{
  global $BELEG;
  $leerzeichen = 25 - strlen(i4l("bu_belege_nr"));
  $BELEG->L_ine (str_pad(i4l("$bezeichnung"),30),"NORMAL");
  $BELEG->L_ine ($inhalt,"FETT",true);
}

// ------------------------------------------------------------------
// Welche Auswahl wurde vorgenommen - Uebergabe ist nur ueber
// Formular zulassig, daher Datenuebergabe in Formular-Klasse
// ------------------------------------------------------------------
$AUSWAHL = $FORM->returnwert ("AUSWAHL");

switch ($AUSWAHL)
{
// ------------------------------------------------------------------
// PDF-Ausgabe
// ------------------------------------------------------------------
  case 'DRUCKEN' :
   include_once "klassen/uvereinpdf.inc";
   $PDF = new cl_uvereinpdf (i4l("beleg_titel").": ".$FORM->returnzahl("nr"),
                             $UVEREIN_DB->get_vereinsname());
   $PDF->table_init (2,"Courier",12,0,array (1,2),array("L","J"));
   $PDF->textzeile ("");
   $PDF->table_line (array(i4l("data_datum"),$FORM->returnwert("datum")));
   $PDF->textzeile ("");
   $PDF->table_line (array(i4l("bu_k_bereich"), 
                           $UVEREIN_DB->sql_1_value("bu_klassen","kl_name",
                            "verein='$VEREIN_NAME' AND kl_nr='".
                            $FORM->returnzahl("bereich")."'")));
   $PDF->table_line (array(i4l("data_buchungskonto"),
                     $UVEREIN_DB->get_kontenname($FORM->returnzahl("konto"))));
   $PDF->table_line (array(i4l("data_finanzkonto"),
                     $UVEREIN_DB->get_kontenname($FORM->returnzahl("fkonto"))));
   $PDF->textzeile ("");
   $PDF->SetLineWidth (0.5); 
   $PDF->Line ($PDF->GetX(),$PDF->GetY(),190,$PDF->GetY());
   $PDF->textzeile ("");
   $PDF->table_line (array(i4l("data_buchungsbetrag"),
                     $FORM->numeingabe2anzeige($FORM->returnwert("betrag"),2)));
   $PDF->textzeile ("");
   $PDF->Line ($PDF->GetX(),$PDF->GetY(),190,$PDF->GetY());
   $PDF->textzeile (i4l("data_buchungstext"),"Courier",10);
   $PDF->textzeile ($FORM->returnwert("inhalt"),"Courier",12);
   $PDF->anzeige();
   break;

// ------------------------------------------------------------------
// Daten erfassen
// ------------------------------------------------------------------  
  default :
// ------------------------------------------------------------------  
// Darstellung erfolgt als HTML
// ------------------------------------------------------------------  
   include_once "klassen/view.inc";
   $BELEG = new cl_view (VIEW_HTML,
                        "uverein &copy; GPL by Uwe Schied",
                        "normal",
                        "../html/schied.css",
                        "../icons/papier2.png");
   $FORM->hide ("AUSWAHL","DRUCKEN");
   $FORM->inhalt ("<H2>".i4l("beleg_titel")."</h2>");
   $FORM->inhalt ("<TABLE>");

// ------------------------------------------------------------------
// Beleg-Nummer = letzte Nr. + 1
// ------------------------------------------------------------------
   $AKT_YEAR = $UVEREIN_DB->sql_1_value ("bu_belege","max (b_jahr)",
                                          "b_verein='$VEREIN_NAME'");   
   form_eintrag ("txt_nr","nr",
                 $UVEREIN_DB->sql_1_value("bu_belege","max(b_nr) + 1",
                                           "     b_verein='$VEREIN_NAME'".
                                           " AND b_jahr='$AKT_YEAR'"));

// ------------------------------------------------------------------
// Beleg-Datum
// ------------------------------------------------------------------
   form_eintrag ("data_datum","datum",date("d.m.Y"));

// ------------------------------------------------------------------
// Kontenklasse als Auswahl-Feld
// ------------------------------------------------------------------
   form_sel ("bu_k_bereich","bereich","bu_klassen","verein='$VEREIN_NAME'","kl_nr",
             "kl_nr","kl_name");

// ------------------------------------------------------------------
// Buchungskonto
// ------------------------------------------------------------------
   array_sel ("data_buchungskonto","konto",$UVEREIN_DB->konten_liste4selection());

// ------------------------------------------------------------------
// Finanzkonto
// ------------------------------------------------------------------
   $data = $UVEREIN_DB->sql_1_value("virtual_konto","konto",
                                    "verein='$VEREIN_NAME' AND art='FINANZKONTO'");
   array_sel ("data_finanzkonto","fkonto",$UVEREIN_DB->konten_liste4selection($data));

// ------------------------------------------------------------------
// Buchungs-Betrag
// ------------------------------------------------------------------
   form_eintrag ("data_buchungsbetrag","betrag");

// ------------------------------------------------------------------
// Buchungstext
// ------------------------------------------------------------------
   $FORM->inhalt ("<TR><TD>".i4l("data_buchungstext")."</td><TD>");
   $FORM->feld("inhalt",100,25);
   $FORM->inhalt ("</TD></TR>");

// ------------------------------------------------------------------
// Formular-Ende
// ------------------------------------------------------------------   
   $FORM->inhalt ("</TABLE>");
   $FORM->grafikbutton ("OK","../icons/ok.png",false);
   $BELEG->L_ine ($FORM->schliessen());                                 
   $BELEG->ende();
   break;

} // ENDE von switch ($AUSWAHL)

?> 