<?php

include_once "base.inc";

// --------------------------------------------------------
// Konstanten anlegen
// --------------------------------------------------------
define ('NAME',         0);
define ('WERT',         1);
define ('ZIEL',         2);
define ('BEREICH',      3);
define ('SEITENLAENGE', 250);  // Laenge der druckbaren Seite in mm

require("fpdf/fpdf.php");

class PDF extends FPDF
{
  var $TabColor;       // Hintergrund der Tabellenzeile
  var $NewPage;        // Seitenwechsel anzeigen
  var $TabSumme;       // Summenzeile hervorheben (ja/nein)

// ------------------------------------------------------------------
// Nicht darstellbare Zeichen in darstellbare konvertieren (intern)
// ------------------------------------------------------------------
function uvereinpdf_caseconvert ($S_OLD)
{
  $S_OLD = str_replace ("&auml;" ,"ä",$S_OLD);
  $S_OLD = str_replace ("&Auml;" ,"Ä",$S_OLD);
  $S_OLD = str_replace ("&ouml;" ,"ö",$S_OLD);
  $S_OLD = str_replace ("&Ouml;" ,"Ö",$S_OLD);
  $S_OLD = str_replace ("&uuml;" ,"ü",$S_OLD);
  $S_OLD = str_replace ("&Uuml;" ,"Ü",$S_OLD);
  $S_OLD = str_replace ("&szlig;","ß",$S_OLD);
  $S_OLD = str_replace ("ä",chr(228),$S_OLD);
  $S_OLD = str_replace ("Ä",chr(196),$S_OLD);
  $S_OLD = str_replace ("ö",chr(246),$S_OLD);
  $S_OLD = str_replace ("Ö",chr(214),$S_OLD);
  $S_OLD = str_replace ("ü",chr(252),$S_OLD);
  $S_OLD = str_replace ("Ü",chr(220),$S_OLD);
  $S_OLD = str_replace ("ß",chr(223),$S_OLD);
  $S_OLD = str_replace ("�",chr(252),$S_OLD);
  return ($S_OLD);
}

// --------------------------------------------------------
// Kopfzeile einstellen
// --------------------------------------------------------
  function Header () 
  {
    $this->SetY(10);
    $this->SetFont('Arial','',20);
    $this->SetTextColor(0);
    $this->SetFillColor(220);
    $this->Cell(0,10,$this->uvereinpdf_caseconvert($this->SetHeader),0,1,'C',1);
    $this->ln();
  }
  
// --------------------------------------------------------
// Fusszeile einstellen
// --------------------------------------------------------
  function Footer ()
  {
    $this->SetLineWidth (0.1);
    $this->AliasNbPages('{MS}');
    $this->SetY(-15);
    $this->SetFont('Arial','',8);
    $this->SetTextColor(127,127,127);
    $this->Cell(0,5,$this->uvereinpdf_caseconvert($this->SetFooter),'T',0,'L');
    $this->SetFont('Arial','',10);
    $this->Cell(0,5,$this->PageNo() . "/{MS}",'T',1,'R');
    $this->NewPage = true;
  }
  
// --------------------------------------------------------
// Tabelle anlegen mit zentrierter Ueberschrift
// --------------------------------------------------------
  function TabHead ($txt)
  {
    $this->ln();    
    $this->SetFont('Arial','',15);
    $this->SetFillColor (230,230,250);
    $this->MultiCell(0,10,$this->uvereinpdf_caseconvert($txt),0,'L',1);
    $this->TabColor = 230;
    $this->TabSumme = false;
  }
// --------------------------------------------------------
// Normale Tabellenzeile mit Text und Wert
// --------------------------------------------------------
  function TabLine ($txt,$wert)
  {
    $this->TabColor = ($this->TabColor != 255) ? 255 : 230;
    $this->SetFont('Courier','',10);
    $this->SetFillColor ($this->TabColor);
    if ($this->TabSumme) $this->SetFillColor (200,220,240);
// Anzahl der moeglichen Zeichen pro Zeile ermitteln 
    $breite = 170 / $this->GetStringWidth("A");
// Text in einzelne Woerter zerlegen    
    $S = ""; $i = 0; $len = $breite - 30;
    $TxArr = explode(" ",$this->uvereinpdf_caseconvert($txt),$len);
// Falls Text nicht in eine Zeile passt auf mehrere Zeilen
// verteilen    
    while ($i < count($TxArr))
    {
      $txlen = strlen($S) + strlen($TxArr[$i]);
      if ($txlen > $len)
      {
        $this->Cell(0,5,$S,0,1,'L',1);
        $S = "";
      }
      $S .= $TxArr[$i] . " ";
      $i++;
    }
// Auf Laenge der ersten Spalte auffuellen    
    while (strlen($S) < $len)
    {
      $S .= ".";
    }
    $len = $breite - 30;
    $cbreite = $len * $this->GetStringWidth("A");
// 1. Spalte ausgeben
    $this->Cell($cbreite,5,$this->uvereinpdf_caseconvert($S),0,0,'L',1); $S = "";
// 2. Spalte ausgeben        
    while (strlen($S) < (20 - strlen($wert))) $S .= " ";
    $this->SetFont('Courier','B',12);
    $this->Cell(0,5,$S.$wert,0,1,'L',1);
  }
} // der Klasse

// --------------------------------------------------------
// Array pruefen
// --------------------------------------------------------
function initial_ARR ($arr, $key)
{
  $arr[$key] = (isset($arr[$key])) ? $arr[$key] : 0;
}

// --------------------------------------------------------
// manueller Seitenumbruch, wenn weiterer Text nicht mehr
// auf die aktuelle Seite passt
// --------------------------------------------------------
function new_page ($mehr)
{
  global $pdf;
  $POSITION = $pdf->GetY() + $mehr;
  if ($POSITION > SEITENLAENGE) $pdf->AddPage();
}

// --------------------------------------------------------
// PDF-Dokument anlegen
// --------------------------------------------------------
$pdf=new PDF("P","mm","A4");
// Waehrungskennzeichen holen
$WAEHRUNGSKZ = " " . $UVEREIN_DB->sql_1_value("bilanz","waehrung",
                     "     verein='".$UVEREIN_DB->get_verein()."'".
                     " AND jahr='".$UVEREIN_DB->get_jahr()."'");
// Vereinsname auf jeder Seite oben zentriert angeben
$pdf->SetHeader = $UVEREIN_DB->get_vereinsname();
// Text für die Fusszeile
$pdf->SetFooter = i4l("bu_bilanz").' '.$UVEREIN_DB->get_jahr();
$pdf->SetLeftMargin(20); $pdf->SetRightMargin(20);
$pdf->AddPage();

// --------------------------------------------------------
// Text >>Gewinn- und Verlustrechnung<< in grosser Schrift
// ausgeben
// --------------------------------------------------------
$pdf->SetFont('Arial','',18);
$pdf->MultiCell(0,10,i4l("bu_bilanz")." $AKT_YEAR",0,'C');

// --------------------------------------------------------
// Konto-Klassen einlesen
// --------------------------------------------------------
$qu = $UVEREIN_DB->sql_befehl 
      ("SELECT * FROM bu_klassen WHERE verein='$VEREIN_NAME'".
       " ORDER BY kl_nr");
$anzahl = $UVEREIN_DB->sql_lines(); $i = 0;
while ($i < $anzahl)
{
  $data = $UVEREIN_DB->sql_line($i,$qu); $i++;
//
// keine Finanzkonten ausgeben
//  
  $ANZEIGETEST = ($data->kl_nr == $UVEREIN_DB->get_vfinanz ()) ? 0 : 1;
//
// Uebertrag nicht ausgeben
//  
  $ANZEIGETEST = ($data->kl_nr == $UVEREIN_DB->get_vuebertrag()) ? 0 : $ANZEIGETEST;
  if ($ANZEIGETEST == 1)
  {
    $KLASSEN_NR    = $data->kl_nr;
    $KLASSEN_NAME  = $data->kl_name;
    $KLASSEN_SUMME = 0;
    $KLASSEN_ZAHL  = 0;
    $UVEREIN_DB->sql_befehl ("SELECT kto_ziel FROM bu_konten WHERE ".
                             "kto_klasse='$data->kl_nr' AND verein='$VEREIN_NAME' ".
                             "AND jahr='$AKT_YEAR' GROUP BY kto_ziel");
    $x = 0; while ($x < $UVEREIN_DB->sql_lines())
    {
      $data = $UVEREIN_DB->sql_line($x); $x++;
      $betrag = $UVEREIN_DB->sum_konto ($data->kto_ziel,1);
//
// Beitragskonto beruecksichtigen
//      
      $betrag += ($data->kto_ziel == $UVEREIN_DB->get_vbeitrag())
               ? $UVEREIN_DB->sum_beitrag()
               : 0; 
//
// Nur beruecksichtigen, wenn nicht 0
//
      if ($betrag <> 0)
      { 
        $INHALT[$x] = $betrag."\t".$UVEREIN_DB->get_kontenname($data->kto_ziel);
        $KLASSEN_ZAHL += 1;
        $KLASSEN_SUMME += $betrag;
      }
    }
    if (isset ($INHALT))
    {
      new_page (($KLASSEN_ZAHL*5));
      $pdf->TabHead ($KLASSEN_NAME);
      rsort ($INHALT,SORT_NUMERIC);
      foreach ($INHALT as $aus)
      {
        $X = explode ("\t",$aus);
        $pdf->TabLine($X[1],number2anzeige($X[0],2).$WAEHRUNGSKZ);
        $SUMME_AUSGEBEN = true;
      } 
      $pdf->TabSumme = true;
      $pdf->TabLine (" "," ");
      $pdf->TabLine (i4l("GESAMT-SUMME"),number2anzeige($KLASSEN_SUMME,2).$WAEHRUNGSKZ);
      $pdf->ln();
      unset ($INHALT);
      $KLASSE [$KLASSEN_NR] = $KLASSEN_NAME . "\t" . $KLASSEN_SUMME;
    }
  }
}

// --------------------------------------------------------
// Uebertrag und Abrechnungsergebnis ausgeben
// --------------------------------------------------------
$pdf->ln();
$pdf->SetLineWidth (1);
$pdf->Line ($pdf->GetX(),$pdf->GetY(),190,$pdf->GetY());
if (isset($KLASSE)) $MERKER = count($KLASSE); else $MERKER = 2; 
new_page (($MERKER*5));
$pdf->TabHead ($UVEREIN_DB->sql_1_value("bu_klassen","kl_name","kl_nr='".
               $UVEREIN_DB->get_vuebertrag()."'"));
$SUMME = $UVEREIN_DB->sum_konto($UVEREIN_DB->get_vuebertrag("FINANZ"));
$pdf->TabLine ($UVEREIN_DB->get_kontenname($UVEREIN_DB->get_vuebertrag("FINANZ")),
               number2anzeige($SUMME,2).$WAEHRUNGSKZ);
if (isset ($KLASSE)) { foreach ($KLASSE as $aus) 
{
  $X = explode ("\t",$aus);
  $pdf->TabLine($X[0],number2anzeige($X[1],2).$WAEHRUNGSKZ);
  $SUMME += $X[1];
  $SUMME_AUSGEBEN = true;
}}
$pdf->TabSumme = true;
$pdf->TabLine (" "," ");
$pdf->TabLine (i4l("GESAMT-SUMME"),number2anzeige($SUMME,2).$WAEHRUNGSKZ);

// --------------------------------------------------------
// Finanzkonten ausgeben
// --------------------------------------------------------
$pdf->ln();
$pdf->SetLineWidth (1);
$pdf->Line ($pdf->GetX(),$pdf->GetY(),190,$pdf->GetY());
$pdf->Line ($pdf->GetX(),$pdf->GetY()+2,190,$pdf->GetY()+2);
$SUMME = 0; $BILANZ = $UVEREIN_DB->sum_finanz();
new_page ((count($BILANZ)*5)+50);
$pdf->TabHead (i4l("FINANZKONTEN"));
foreach ($BILANZ as $NR => $WERT) 
{
  if ($WERT != 0)
    $pdf->TabLine ($UVEREIN_DB->get_kontenname($NR),number2anzeige($WERT,2).$WAEHRUNGSKZ);
  $SUMME += $WERT; 
}
$pdf->TabSumme = true;
$pdf->TabLine (" "," ");
$pdf->TabLine (i4l("GESAMT-SUMME"),number2anzeige($SUMME,2).$WAEHRUNGSKZ);

// --------------------------------------------------------
// Schlusstext ausgeben
// --------------------------------------------------------
$UVEREIN_DB->sql_befehl (
  "SELECT * FROM bilanz WHERE jahr='$AKT_YEAR' AND verein='$VEREIN_NAME'");
$data = $UVEREIN_DB->sql_line (0);
$pdf->ln();
$pdf->SetLineWidth (1);
$pdf->Line ($pdf->GetX(),$pdf->GetY(),190,$pdf->GetY());
$pdf->Line ($pdf->GetX(),$pdf->GetY()+2,190,$pdf->GetY()+2);
$pdf->ln();
$pdf->SetFont('Arial','',12);
$pdf->MultiCell (0,5,$pdf->uvereinpdf_caseconvert($data->schlusstxt),0,'L',0);
$pdf->ln();
$xpos = $pdf->GetX() + $pdf->GetStringWidth($data->datum) + 4;
$pdf->SetLineWidth (0.2);
$pdf->Line ($xpos,$pdf->GetY()+2,200-$xpos,$pdf->GetY()+2);
$pdf->ln();
$pdf->MultiCell (0,5,$pdf->uvereinpdf_caseconvert($data->prueftxt),0,'L',0);
$pdf->ln();
$pdf->Cell(0,5,$data->datum,0,1,'L',0);
$pdf->Line ($xpos,$pdf->GetY(),200-$xpos,$pdf->GetY());
$pdf->Line ($xpos,$pdf->GetY()+20,200-$xpos,$pdf->GetY()+20);
// --------------------------------------------------------
// PDF-Dokument abschliessen und ausgeben
// --------------------------------------------------------
$pdf->SetDisplayMode ("fullwidth");
$NAME = "../tmp/bilanz_".$VEREIN_NAME."_$AKT_YEAR.pdf";
$pdf->Output ($NAME,"F");
echo "<SCRIPT language=\"JavaScript\"> self.location.href=\"$NAME\"; </SCRIPT>";
?> 