<?php
//****h* Finanzbuchhaltung/buchung_beleg.php
// NAME
//   buchung_beleg.php
// BESCHREIBUNG
//   Erstellt eine Aufstellung der Buchungsbelege mit allen
//   Belegen des aktuellen Jahres
//***
include_once "base.inc";
include_once "header.inc";
//
// Ueberschrift
//
$FORM->inhalt("<TABLE><TR>");
$FORM->inhalt ("<TD><H1>". i4l("bu_belege") . " $AKT_YEAR</H1></TD>");
//
// PDF anbieten
//
$FORM->inhalt("<TD>");
$FORM->sub_grafikbutton("../icons/pdf-sum.png","","print.belege-sum.php");
$FORM->inhalt("</TD><TD>");
$FORM->sub_grafikbutton("../icons/pdf.png","","print.belege.php");
$FORM->inhalt("</TD></TR></TABLE>");
// 
// Tabelle erstellen
//
$FORM->inhalt ("<TABLE class=\"breite100\" border=1>");
$FORM->inhalt ("<TR><TH>".i4l("aktion")."</TH>");
$FORM->inhalt ("<TH>".i4l("data_nr")."</TH>");
$FORM->inhalt ("<TH>".i4l("data_datum")."</TH>");
$FORM->inhalt ("<TH>".i4l("data_konto")."</TH>");
$FORM->inhalt ("<TH>".i4l("data_finanzkonto")."</TH>");
$FORM->inhalt ("<TH>".i4l("data_buchungsbetrag")."</TH>");
$FORM->inhalt ("<TH>".i4l("data_uststeuer")."</TH>");
$FORM->inhalt ("<TH>".i4l("data_buchungstext")."</TH>");
$FORM->inhalt ("<TH>".i4l("bu_kst")."</TH></TR>");
//
// Summen initialisieren
//
$BETRAG = 0.00;
$STEUER = 0.00;
//
// Belege anzeigen
//
$FARBE = "ID=\"grau\"";
$FINANZKONTEN = $UVEREIN_DB->get_vfinanz();
$UVEREIN_DB->get_beleg ("","b_nr,b_datum");
$i = 0; while ($i < $UVEREIN_DB->sql_lines())
{
	$data = $UVEREIN_DB->sql_line($i); $i++;
	$FARBE = ($FARBE == "") ? "ID=\"grau\"" : "";
	$FORM->inhalt ("<TR $FARBE><TD>");
// Edit-Button mit Ziel verbinden
	$X = array ("AUSWAHL" => "BUCHUNG_UPDATE", "NR" => $data->idx);
	$FORM->sub_grafikbutton("../icons/edit.png",$X,"buchung.php");
	$FORM->inhalt("</TD>");
// Belegzeile
	$FORM->inhalt("<TD>$data->b_nr</TD>");
	$FORM->inhalt("<TD>$data->b_datum</TD>");
	$FORM->inhalt("<TD>".$UVEREIN_DB->get_kontenname($data->b_konto)."</TD>");
	$FORM->inhalt("<TD>".$UVEREIN_DB->get_kontenname($data->f_konto)."</TD>");
// Pruefen auf Finanzkonto
//   Kein Finanzkonto  = Umbuchung innerhalb der Vereinskonten
//   Ein  Finanzkonto  = Echte Buchung
//   Zwei Finanzkonten = Umbuchung innerhalb der Finanzkonten
	$UMBUCHUNG = ($UVEREIN_DB->get_kontenklasse($data->b_konto) == $FINANZKONTEN) ? 1 : 0;
	$UMBUCHUNG += (($UVEREIN_DB->get_kontenklasse($data->f_konto) == $FINANZKONTEN) ? 1 : 0);
	$BUCHUNG = ($UMBUCHUNG == 1)
	         ? $FORM->numeingabe2anzeige($data->b_betrag,2)
	         : "+/- ". $FORM->numeingabe2anzeige($data->b_betrag * (($data->b_betrag < 0) ? -1 : 1),2);
	$FORM->inhalt("<TD id=\"rechts\">$BUCHUNG</TD>");
	$BETRAG += ($UMBUCHUNG == 1) ? $data->b_betrag : 0;
	$FORM->inhalt("<TD id=\"rechts\">".$FORM->numeingabe2anzeige($data->b_steuer,2)."</TD>");
	$STEUER += $data->b_steuer;
	$FORM->inhalt("<TD>$data->b_text</TD>");
	$FORM->inhalt("<TD>".$UVEREIN_DB->sql_1_value("bu_kst","kst_name",
	                     "verein='$VEREIN_NAME' AND kst='$data->b_kst'").
	              "</TD></TR>");
}
//
// Beitragskonto aus Mitgliederverwaltung ergaenzen
//
$KONTO = $UVEREIN_DB->get_kontenname ($UVEREIN_DB->get_vbeitrag());
$KST   = $UVEREIN_DB->sql_1_value("bu_kst","kst_name","verein='$VEREIN_NAME'".
         " AND kst='".$UVEREIN_DB->get_vbeitrag("KST")."'");
$UVEREIN_DB->get_beitraege(); $i = 0; while ($i < $UVEREIN_DB->sql_lines())
{
	$data = $UVEREIN_DB->sql_line($i); $i++;
	$FARBE = ($FARBE == "") ? "ID=\"grau\"" : "";
	$FORM->inhalt ("<TR $FARBE><TD>&nbsp;</TD><TD>&nbsp;</TD>");
	$FORM->inhalt("<TD>31.12.$AKT_YEAR</TD>");
	$FORM->inhalt("<TD>$KONTO</TD>");
	$FORM->inhalt("<TD>".$UVEREIN_DB->get_kontenname($data->f_konto)."</TD>");
	$FORM->inhalt("<TD id=\"rechts\">".$FORM->numeingabe2anzeige($data->haben,2)."</TD>");
	$BETRAG += $data->haben;
	$FORM->inhalt("<TD>&nbsp;</TD>");
	$FORM->inhalt("<TD>".i4l("MENU_TITLE_BEITRAG")."</TD>");
	$FORM->inhalt("<TD>$KST</TD></TR>");
}
//
// Summen ausgeben
//
$FORM->inhalt("<TR ID=\"gelb\"><TD colspan=\"5\">&nbsp;</TD>");
$FORM->inhalt("<TD id=\"rechts\">".$FORM->numeingabe2anzeige($BETRAG,2)."</TD>");
$FORM->inhalt("<TD id=\"rechts\">".$FORM->numeingabe2anzeige($STEUER,2)."</TD>");
$FORM->inhalt("<TD colspan=\"2\">&nbsp;</TD></TR>");
$FORM->inhalt("<TR><TD colspan=\"5\">&nbsp;</TD>");
$FORM->inhalt("<TD id=\"rechts\"><strong>".
              $FORM->numeingabe2anzeige($BETRAG+$STEUER,2).
              "</strong></TD>");
$FORM->inhalt("<TD id=\"rechts\">&nbsp;</TD>");
$FORM->inhalt("<TD colspan=\"2\">&nbsp;</TD></TR>");
// Tabelle schliessen
//
$FORM->inhalt("</TABLE>");

echo page_head ("");
echo $FORM->schliessen();
echo page_ende();
?>