<?php
//****h* /funktionen.php
// NAME
//   funktionen.php 
//   Die Datei enthaelt die global verwendete Funktionen-Bibliothek
// AUTOR
//   Uwe Schied
// COPYRIGHT
//   GPL
// BUGS
//   kein BUG bekannt
//*****

if (! empty($PROJECT_TEST_MODE))
{
  if ($PROJECT_TEST_MODE == "YES") error_reporting (E_ALL);
}
else $PROJECT_TEST_MODE = "NO";

// ----------------------------------------------------------------------------
// Cookie's setzen
// ----------------------------------------------------------------------------

function make_tempname ($name)
{
  global $PROJEKT;
  return ("../tmp/" . $PROJEKT . time() . "." . $name);
}

function cookie_setzen ($name, $inhalt,$dauer)
{
  global $PROJEKT;
  $name = $PROJEKT . "_COOKIE__". strtoupper ($name);
  if (!empty($_COOKIE[$name])) // Cookie existiert
  {
    setcookie ($name,"",time() - 3600); // loeschen
  }
  if (empty($dauer)) setcookie ($name,$inhalt);        // Cookie anlegen - Lebensdauer: aktuelle Sitzung
  else               setcookie ($name,$inhalt,$dauer); // Cookie anlegen - Lebensdauer wird angegeben
}

function cookie_einmalsetzen ($name, $inhalt)
{
  global $PROJEKT;
  $NAME = $PROJEKT . "_COOKIE__". strtoupper ($name);
  if (empty($_COOKIE [ $NAME ])) // Cookie existiert nicht
  {
    cookie_setzen ($name,$inhalt,"");
  }
}

function cookie_for_file ($name)
{
  global $PROJEKT;
  $NAME = $PROJEKT . "_COOKIE__". strtoupper ($name);
  if (empty($_COOKIE[$NAME])) // Cookie existiert nicht
  {
    $inhalt = make_tempname ("cookie");
    cookie_setzen ($name,$inhalt,"");
  }
}

function cookie_lesen ($name)
{
  global $PROJEKT;
  $name = $PROJEKT . "_COOKIE__". strtoupper ($name);
  return ((empty($_COOKIE[$name])) ? "" : $_COOKIE[$name]);
}

function cookie_base ($name,$config,$set_new)
{
  if (!empty($set_new))
  {
    cookie_setzen ("$name",$set_new,time()+10000000);
  }
  else
  {
    $set_new = cookie_lesen ($name);
    if (empty($set_new))
    {
      cookie_setzen ("$name",$config,time()+10000000);
    }
  }
}

//
// Cookie fuer die Hilfefunktion setzten
//
function register_help_pos ($name)
{
  cookie_base ("HELP_POS","HELP_POS",strtoupper($name));  
}

// -----------------------------------------------------------------------------
// Shell-Befehle ausfuehren
// -----------------------------------------------------------------------------

function open_new_window ($name)
{
  echo "<SCRIPT language=\"JavaScript\">window.open(\"$name\",\"_blank\");</SCRIPT>";
}

function shell_testing_window ($cmd,$inhalt)
{
  $F = fopen(cookie_lesen ("PRINT") . ".html","w");
  fwrite ($F,"<HTML><HEAD><TITLE>$cmd</TITLE></HEAD>");
  fwrite ($F,"\n<BODY>");
  fwrite ($F,"\n<BR><HR><A href=\"javascript:self.close();\">C L O S E</A><HR>");
  fwrite ($F,"\n$inhalt");
  fwrite ($F,"\n<BR><HR><A href=\"javascript:self.close();\">C L O S E</A><HR>");
  fwrite ($F,"\n</BODY></HTML>");
  fclose ($F);
  open_new_window (cookie_lesen ("PRINT") . ".html");
}

function shell_execute ($cmd, $testing)
{
  $testing = trim(strtoupper($testing));
  $fname = make_tempname ("execute");
  $F = fopen ($fname,"w");
  fwrite ($F,"#! /bin/sh\n");
  fwrite ($F,$cmd);
  fclose ($F);
  $CMD = ". $fname";
  $ERROR = 0;
  $CMD_RETURN = `$CMD`;
  if ($testing == "YES")
  {
    shell_testing_window ($cmd,
	"<HR><U>Command:</U><BR>$cmd<HR>" .
        "<PRE>$CMD_RETURN</PRE>");
  }
  unlink ($fname);
  return ($CMD_RETURN);
}

function user_execute ($cmd)
{
  shell_execute (EscapeShellCmd($cmd),"NO");
}

// -----------------------------------------------------------------------------
// Uebersetzung
// -----------------------------------------------------------------------------

function i4l ($name)
{
  global $SPRACHE;
  $g_esucht = strtoupper($name);
  $F_ilename = strtolower("i18n/language-modul.$SPRACHE.lang");
  if (! file_exists($F_ilename))
  {
    $F_ilename = "i18n/language-modul.c.lang";
  }
  $F = fopen ($F_ilename,"r");
  $F_inde = 0; $ret = "";
  while (($F_inde == 0) && (!feof($F)))
  {
    $S = fgets ($F,2048);
    $S_Arr = explode ("\t", $S);
    if ($S_Arr[0] == $g_esucht)
    {
      $F_inde = 1;
      $ret = trim ($S_Arr[1]);
    }
  }
  fclose($F);
  if ($F_inde == 0)
  {
    $F = fopen ("i18n/language-modul.c.lang","r");
    $F_inde = 0; $ret = "";
    while (($F_inde == 0) && (!feof($F)))
    {
      $S = fgets ($F,2048);
      $S_Arr = explode ("\t", $S);
      if ($S_Arr[0] == $g_esucht)
      {
        $F_inde = 1;
        $ret = trim ($S_Arr[1]);
      }
    }
    fclose($F);
  }
  return ($ret);
}

function i4l_newlanguage ($name, $comment)
{
  $F_ilename = "i18n/language-modul._available";
  $T_emp     = dirname (__FILE__) . "/../tmp/language-modul._available";
  $g_esucht = trim(strtoupper($name));
  $comment  = trim ($comment);
  $eingefuegt = 0;
  $F = fopen ($F_ilename,"r");
  $F_neu = fopen ($T_emp,"w+");
  while (!feof($F))
  {
    $S = fgets ($F,2048);
    $S_Arr = explode ("\t", $S);
    if (($S_Arr[0] > $g_esucht) && ($eingefuegt == 0))
    {
      fwrite ($F_neu,"$g_esucht\t$comment\n");
      $eingefuegt++;
    }
    $a = (empty($S_Arr[0])) ? "" : trim ($S_Arr[0]);
    $b = (empty($S_Arr[1])) ? "" : trim ($S_Arr[1]);
    if (strlen($a) > 0) fwrite ($F_neu,"$a\t$b\n");
  }
  if ($eingefuegt == 0) fwrite ($F_neu,"$g_esucht\t$comment\n");
  fclose($F); fclose($F_neu);
  copy ($T_emp,$F_ilename);
  $modul = strtolower($name);
  copy ("i18n/language-modul.c.lang","i18n/language-modul.$modul.lang");
}

function i4l_viewlanguage ($name)
{
  $F_ilename = "i18n/language-modul._available";
  $g_esucht = trim(strtoupper($name));
  $g_funden = 0;
  $F = fopen ($F_ilename,"r");
  while (!feof($F))
  {
    $S = fgets ($F,2048);
    $S_Arr = explode ("\t", $S);
    $akt = trim ($S_Arr[0]);
    if ($akt == $g_esucht)
    {
      $g_funden++;
      $ret = trim ($S_Arr[1]);
    }
  }
  if ($g_funden == 0) $ret = i4l_viewlanguage("C");
  return ($ret);
}

// -----------------------------------------------------------------------------
// Speichern, welches Anzeigefenster aktiv ist !
// -----------------------------------------------------------------------------

function index_anzeige ()
{
  cookie_base ("ANZEIGE_FILE","ANZEIGE_FILE",$_SERVER["REQUEST_URI"]);
}

// -----------------------------------------------------------------------------
// Format-Umrechnung
// -----------------------------------------------------------------------------

function number2anzeige ($zahl, $nachkomma)
{
  $tausend = "."; $trenner = ",";
  $zahl = trim ($zahl);
  $zahl = number_format ($zahl,$nachkomma);
  $zahl = str_replace (".","|",$zahl);
  $zahl = str_replace (",",$tausend,$zahl);
  $zahl = str_replace ("|",$trenner,$zahl);
  return $zahl;
}

function anzeige2number ($zahl)
{
  $tausend = "."; $trenner = ",";
  return str_replace ("|",".",
         str_replace ($trenner,".",
	 str_replace ($tausend,"",
	 trim($zahl))));
}

function sonderzeichen2html ($ALT)
{
  $TConvert = array ("ä" => "&auml;" ,"" => "&auml;",
                     "Ä" => "&Auml;" ,"" => "&Auml;",
	  	               "ö" => "&ouml;" ,"" => "&ouml;",
		               "Ö" => "&Ouml;" ,"" => "&Ouml;",
		               "ü" => "&uuml;" ,"" => "&uuml;",
		               "Ü" => "&Uuml;" ,"" => "&Uuml;",
		               "ß" => "&szlig;","" => "&szlig;"
		              );
  $T = strtr ($ALT,$TConvert);
  return ($T);
}

// -----------------------------------------------------------------------------
// Allgemeine Auswertungen
// -----------------------------------------------------------------------------
function is_alpha ($c)
{
  $ret = 0;
  $x = ord ($c);
  $i = ord ("a");
  while ($i < ord ("z"))
  {
    if ($x == $i) $ret = 1;
    $i++;
  }
  return ($ret);
}

function is_number ($c)
{
  $ret = 0;
  $x = ord ($c);
  $i = ord ("0");
  while ($i < ord ("9"))
  {
    if ($x == $i) $ret = 1;
    $i++;
  }
  return ($ret);
}

function psql_tablename ($name)
{
  $FIRST = substr($name,0,1);
  $LAST  = substr($name,1);
  $ret = (is_alpha ($FIRST) == 1) ? $FIRST : "_";
  $i = 0; while ($i < strlen($LAST))
  {
    $ret .= ( is_alpha (substr($LAST,$i,1)) == 1) ? substr($LAST,$i,1) :
            ((is_number (substr($LAST,$i,1)) == 1) ? substr($LAST,$i,1) : "_");
    $i++;
  }
  return ($ret);
}

// -----------------------------------------------------------------------------
// Grundeinstellungen einlesen
// Globale Variablen setzen
// 	- $PROJEKT
// -----------------------------------------------------------------------------

if (empty($PROJEKT))               $PROJEKT  = "uverein";        // Projekt-Name = Voreinstellung

cookie_for_file ("PRINT");

?>
