<?php
//****M* Datenbank-Klasse/Tabelle: bu_konten +002+
// NAME
//   php/klassen/uverein-database.002.inc
// KLASSE 
//   cl_uverein_database_002
//   Klasse fuer den Zugriff auf die Tabelle bu_konten
// ABHAENGIG VON
//   cl_database              (database.inc)
//   cl_uverein_database_001  (uverein-database.001.inc)
//   PHP 5
// HISTORIE
//   21.03.2009 FUNKTION konten_liste
//   22.03.2009 FUNKTION kontenname
//   10.04.2009 Tabelle bu_konten ausgelagert in cl_uverein_database_002
// AUTOR
//   Uwe Schied
// BUGS
//   keine bekannt
//****

include_once (dirname (__FILE__) . "/uverein-database.001.inc");

class cl_uverein_database_002 extends cl_uverein_database_001 { 
function __construct($name, $schema = "public") 
{
   parent::__construct ($name,$schema);
}                      

//****f* Tabelle: bu_konten +002+/konto_eintragen (Konto-Nr, Name, Klasse, Ziel, Jahr, Kontostand)
// FUNCTION
//   konto_eintragen   Neues Konto erfassen oder aendern
//      $nr        Konto-Nr
//      $name      optionale Bezeichnung des Konto's
//      $klasse    optionale Kontenklasse (Voreinstellung = 0)
//      $ziel      optionales Konto, auf das der Abschluss erfolgt
//                 (Voreinstellung = Bilanz)
//      $jahr      optionale Angabe des Jahres 
//                 (Voreinstellung = aktuelles Jahr)
//      stand      optionaler Kontostand (Voreinstellung 0)
// ERGEBNIS
//   Das Konto wurde entweder neu eingetragen oder aktualisiert
//****
public function konto_eintragen ($nr, 
                                 $name = "", 
                                 $klasse = -1, 
                                 $ziel = -1, 
                                 $jahr = NULL, 
                                 $stand = "")
{
  $jahr = ($jahr == NULL) ? $this->SET_JAHR : $jahr;
  $ziel = ($ziel == -1)   ? $nr : $ziel;
  // Pruefen ob das Konto bereits vorhanden ist
  $this->sql_befehl ("SELECT * FROM bu_konten".
                     " WHERE kto_nr='$nr' AND verein='$this->SET_VEREIN' AND jahr='$jahr'");
  if ($this->sql_lines() > 0) // UPDATE erforderlich
  {
    $SET  = "kto_nr='$nr'";
    $SET .= ($name == "")   ? "" : ", kto_name='$name'";
    $SET .= ($klasse == -1) ? "" : ", kto_klasse='$klasse'";
    $SET .= ($ziel == -1)   ? "" : ", kto_ziel='$ziel'";
    $SET .= ($stand == "")  ? "" : ", kto_stand='$stand'";
    $this->sql_befehl ("UPDATE bu_konten SET $SET".
                       " WHERE kto_nr='$nr' AND verein='$this->SET_VEREIN' AND jahr='$jahr'");   
  }
  else // Neueintrag
  {
    $SET  = ($name == "")   ? "'?'" : "'$name'";
    $SET .= ",";
    $SET .= ($klasse == -1) ? "'0'" : "'$klasse'";
    $SET .= ",";
    $SET .= ($ziel == -1)   ? "'$nr'" : "'$ziel'";
    $SET .= ",";
    $SET .= ($stand == "")  ? "'0'" : "'$stand'";
    $SET .= ",";
    $SET .= "'$jahr'";
    $this->sql_befehl ("INSERT INTO bu_konten".
                       " (verein,kto_nr,kto_name,kto_klasse,kto_ziel,kto_stand,jahr)".
                       " VALUES ('$this->SET_VEREIN','$nr',$SET)");
  }
} 

//****f* Tabelle: bu_konten +002+/konten_liste (Kontenart)
// FUNCTION
//   konten_liste   Array mit allen Konten zu aktuellem Verein und Jahr
//   $kontenart     optionale Beschraenkung auf Kontenklasse
// ERGEBNIS
//   Es wird ein Zeiger auf die selektierten Elemente zurueck gegeben
//****
public function konten_liste ($kontenart = NULL)
{
  $kontenklasse = ($kontenart == NULL) ? "" : "AND kto_klasse='$kontenart'";
  $this->sql_abfrage ("bu_konten, bu_klassen",
                       "     bu_konten.verein='$this->SET_VEREIN'".
                       " AND bu_konten.jahr='$this->SET_JAHR'".
		                 " AND bu_konten.verein=bu_klassen.verein".
		                 " $kontenklasse AND kto_klasse=kl_nr",
		                 "kto_klasse,kto_nr","");
  return ($this->qu);
} 

//****f* Tabelle: bu_konten +002+/konten_liste4selection (Kontenart)
// FUNCTION
//   konten_liste4selection Array mit den Konten zum aktuellen Verein und
//                          Jahr aufbereitet fuer Selektionen
//   $kontenart             Kontenklasse
// ERGEBNIS
//   Es wird ein Array mit folgenden Daten zurueck gegeben:
//     KEY        Konto-Nr
//     VALUE      Bezeichnung der Kontenklasse aus bu_klassen
//                + Bezeichnung des Konto's
//****
public function konten_liste4selection ($kontenart = NULL)
{
  $kontenklasse = ($kontenart == NULL) ? "" : "AND kto_klasse='$kontenart'";
  $this->sql_abfrage ("bu_konten, bu_klassen",
                       "     bu_konten.verein='$this->SET_VEREIN'".
                       " AND bu_konten.jahr='$this->SET_JAHR'".
		                 " AND bu_konten.verein=bu_klassen.verein".
		                 " $kontenklasse AND kto_klasse=kl_nr",
		                 "kto_klasse,kto_nr","");
  $qu = $this->qu; $sql_zeilen = $this->sql_lines($qu);
  if ($sql_zeilen > 0)
  {
    $sql_zaehler=0; while ($sql_zaehler < $sql_zeilen)
	 {
	   $data = $this->sql_line ($sql_zaehler,$qu);
	   $KONTEN_LISTE [$data->kto_nr] = $data->kl_name.': '.$data->kto_name;
      $sql_zaehler++;
    }
  }
  return ($KONTEN_LISTE);
} 

//****f* Tabelle: bu_konten +002+/get_kontodaten (Konto-Nr)
// FUNCTION
//   get_kontodaten     Zeiger auf die Daten des/der Kontos/Konten
//   $nr                optionale Konto-Nummer 
//****
public function get_kontodaten ($nr = "")
{
  $nr = ($nr == "") ? "" : "AND kto_nr='$nr'";
  return ($this->sql_befehl ("SELECT * FROM bu_konten WHERE ".
          "verein='$this->SET_VEREIN' AND jahr='$this->SET_JAHR' $nr ORDER BY kto_nr"));
}

//****f* Tabelle: bu_konten +002+/get_kontenname (Konto-Nr)
// FUNCTION
//   get_kontenname     Name eines kontos ermitteln - bu_konten.name
//   $nr                Konto-Nummer
//****
public function get_kontenname ($nr)
{
  return ($this->sql_1_value("bu_konten","kto_name",
          "verein='$this->SET_VEREIN' AND jahr='$this->SET_JAHR' AND kto_nr='$nr'"));
}

//****f* Tabelle: bu_konten +002+/get_kontenklasse (Konto-Nr)
// FUNCTION
//   get_kontenklasse   Art (Klasse) des Kontos ermitteln
//   $nr                Konto-Nummer
//****
public function get_kontenklasse ($nr)
{
  return ($this->sql_1_value("bu_konten","kto_klasse",
          "verein='$this->SET_VEREIN' AND jahr='$this->SET_JAHR' AND kto_nr='$nr'"));
}

//****f* Tabelle: bu_konten +002+/select_konten (WHERE-Abfrage, Sortierung)
// FUNCTION
//   select_konten      Name eines kontos ermitteln - bu_konten.name
//   $where             optionale zusätzliche Selektion
//   $order             optionale Sortierung
// ERGEBNIS
//   Es wird ein Zeiger auf das Abfrageergebnis zurueck gegeben. Wenn kein 
//   weiteres Selektionsmerkmal mit uebergeben wird ist dies ein Zeiger
//   auf alle Konten des aktuellen Vereins im aktuellen Jahr.
//****
public function select_konten ($where = "", $order = "")
{
  $where = ($where == "") ? "" : "AND ".$where;
  $order = ($order == "") ? "" : "ORDER BY ".$order;
  return ($this->sql_befehl ("SELECT * FROM bu_konten WHERE ".
          "verein='$this->SET_VEREIN' AND jahr='$this->SET_JAHR' $where $order"));
}

} // ENDE der Klasse

?>