<?php
//****M* Datenbank-Klasse/Tabelle: bu_belege +004+
// NAME
//   php/klassen/uverein-database.004.inc
// KLASSE 
//   cl_uverein_database_004
//   Klasse fuer den Zugriff auf die Tabelle bu_belege
// ABHAENGIG VON
//   Klasse                   Datei                    Hinweis
//   ---------------------------------------------------------------------
//   cl_database              database.inc             Datenbank-Klasse
//   cl_uverein_database_001  uverein-database.001.inc Basis-Informationen
//   cl_uverein_database_002  uverein-database.002.inc bu_konten
//   cl_uverein_database_003  uverein-database.003.inc virtual_konto
//   PHP 5
// BESCHREIBUNG
//
// HISTORIE
//   12.12.2009 Klasse erstellt
//   12.12.2009 public  function beleg_insert erstellt
//   20.12.2009 private function test_log erstellt 
//   20.12.2009 public  function beleg_update erstellt
//   23.12.2009 public  function get_beleg erstellt
//   01.01.2010 public  function sum_finanz erstellt
//   03.11.2012 neue Spalte "erledigt" berücksichtigen
// AUTOR
//   Uwe Schied
// BUGS
//   keine bekannt
//****

include_once (dirname (__FILE__) . "/test-log.inc");

include_once (dirname (__FILE__) . "/uverein-database.003.inc");
class cl_uverein_database_004 extends cl_uverein_database_003 { 
function __construct($name, $schema = "public") 
{
   parent::__construct ($name,$schema);
   $this->error_name (CL_DATABASE_ERROR_004_INSERT,"INSERT-ERROR in table bu_belege");
   $this->error_name (CL_DATABASE_ERROR_004_UPDATE,"UPDATE-ERROR in table bu_belege");
}

//****f* Tabelle: bu_belege +004+/test_log
// FUNCTION
//   test_log
//   Diese Funktion ist Klassen-Intern definiert und außerhalb der Klasse nicht 
//   aufrufbar.
//****
private function testlog ($func, $inhalt)
{/*
	$TESTLOG_TRENNER = "\n                    * "; 
  test_log (                   "cl_uverein_database_004->$func".
            $TESTLOG_TRENNER . $inhalt.
            $TESTLOG_TRENNER . "ERRORCODE = $this->ERRORCODE".
            $TESTLOG_TRENNER . "ERRORTEXT = ".$this->error_text().
            $TESTLOG_TRENNER . " ------------------------ ");
*/}

//****f* Tabelle: bu_belege +004+/beleg_insert
// FUNCTION
//   beleg_insert  Neuen Beleg eintragen
//     $beleg      Array mit den einzutragenden Daten des Belegs
//     $jahr       optionale Angabe des Buchungsjahres
// BEISPIEL
//   $EINTRAGEN = array ("b_nr" => "100", "b_datum" => "12.12.2009", 
//                       "b_konto" => "1000", "f_konto" => "2000",
//                       "b_betrag" => "10.99", "b_text" => "Beispieleintrag",
//                       "b_kst" => "1");
//   $datenbank->beleg_insert ($EINTRAGEN);
// ERGEBNIS
//   Beleg wird eingetragen - im Fehlerfall wird CL_DATABASE_ERROR_004_INSERT
//   in $ERRORCODE zurueckgeliefert
//****
public function beleg_insert ($beleg, $jahr = "")
{
  $VAL_UE = "b_verein,b_jahr";
  $INS_ER = "'$this->SET_VEREIN',".(($jahr == "") ? "'$this->SET_JAHR'" : "'$jahr'");
  foreach ($beleg as $key => $inhalt)
  {
    $VAL_UE .= ",\"$key\"";
    $INS_ER .= ",'$inhalt'";
  }
  $BEFEHL = "INSERT INTO bu_belege ($VAL_UE) VALUES ($INS_ER);";
  $this->sql_befehl ($BEFEHL);
  $this->ERRORCODE = ($this->ERRORCODE == CL_DATABASE_OK) ? CL_DATABASE_OK : CL_DATABASE_ERROR_004_INSERT;
  $this->testlog ("beleg_insert",$BEFEHL);
} 

//****f* Tabelle: bu_belege +004+/beleg_update
// FUNCTION
//   beleg_update  Beleg aendern
//     $ident      Beleg, der geaendert werden soll
//     $beleg      Array mit den einzutragenden Daten des Belegs
// BEISPIEL
//   $EINTRAGEN = array ("b_nr" => "100", "b_datum" => "12.12.2009", 
//                       "b_konto" => "1000", "f_konto" => "2000",
//                       "b_betrag" => "10.99", "b_text" => "Beispieleintrag",
//                       "b_kst" => "1");
//   $datenbank->beleg_update ("idx='120'",$EINTRAGEN);
// ERGEBNIS
//   Beleg wird geaendert - im Fehlerfall wird CL_DATABASE_ERROR_004_UPDATE
//   in $ERRORCODE zurueckgeliefert
//****
public function beleg_update ($ident, $beleg)
{
  $WHERE = "b_verein='$this->SET_VEREIN'";
  $WHERE .= ($ident == "") ? "" : " AND $ident";
  $BEFEHL = "UPDATE bu_belege SET b_verein='$this->SET_VEREIN'";
  foreach ($beleg as $key => $inhalt)
  {
    $BEFEHL .= ", $key='$inhalt'";
  }
  $BEFEHL .= " WHERE $WHERE;";
  $this->sql_befehl ($BEFEHL);
  $this->ERRORCODE = ($this->ERRORCODE == CL_DATABASE_OK) ? CL_DATABASE_OK : CL_DATABASE_ERROR_004_UPDATE;
}

//****f* Tabelle: bu_belege +004+/get_beleg
// FUNCTION
//   get_beleg  Beleg(e) holen
//     $find    WHERE fuer den SQL-Befehl
//     $order   optionales ORDER für den SQL-Befehl
// BEISPIEL
//   $Datenbank->get_beleg ("","b_nr,b_datum");
//   $i = 0; while ($i < $Datenbank->sql_lines ())  
//   { $data = $Datenbank->sql_line($i); echo $data->b_text; $i++; }
// ERGEBNIS
//   Datenbank wird entsprechend den uebergebenen Parametern durchsucht und
//   die gefundenen Belege koennen ueber die Datenbankabfragen abegeholt 
//   werden.
//****
public function get_beleg ($find = "", $order = "")
{
  $WHERE = "WHERE b_verein='$this->SET_VEREIN' AND b_jahr='$this->SET_JAHR'";
  $WHERE .= ($find == "") ? "" : " AND ($find)";
  $ORDER = ($order == "") ? "" : "ORDER BY $order";
  $BEFEHL = "SELECT * FROM bu_belege $WHERE $ORDER";
  $this->sql_befehl ($BEFEHL);
  $this->testlog ("get_beleg",$BEFEHL);
  return ($this->qu);
}

//****f* Tabelle: bu_belege +004+/sum_finanz
// FUNCTION
//   sum_finanz Summen der Finanzkonten holen 
// BEISPIEL
//   $KTO = $Datenbank->sum_finanz();
//   $SUMME = 0; foreach ($KTO as $NR => $WERT) 
//   {
//     echo "<bR>$NR ".$Datenbank->get_kontenname($NR)." = $WERT";
//     $SUMME += $WERT; 
//   }
//   echo "<bR>GESAMT = $SUMME";
// ERGEBNIS
//   Es wird ein Array mit dem Inhalt der Finanzkonten erzeugt. Als 
//   Key wird die Konto-Nr. und als Inhalt der Kontostand zurueck ge-
//   geben. Beitragsbuchungen aus der Tabelle 'beitrag' werden berueck-
//   sichtigt.
//****
public function sum_finanz ()
{
  // Finanzkonten holen
  $FKto = $this->konten_liste ($this->get_vfinanz());
  // Standard-Einstellungen
  $BASIS = "b_verein='$this->SET_VEREIN' AND b_jahr='$this->SET_JAHR'";
  // Umsatzsteuer: Konto holen und initialisieren
  $USTKto = $this->get_vsteuer ("FINANZ");
  $KONTEN [$USTKto] = 0;
  // Array mit Kontenname und -Summe erstellen
  $FMax = $this->sql_lines ($FKto); $i = 0; 
  while ($i < $FMax)
  {
    $data = $this->sql_line ($i,$FKto); $i++;
    $KONTEN [$data->kto_nr] = $this->sql_1_value ("bu_belege","sum(b_betrag)",
                              "f_konto='$data->kto_nr' AND $BASIS");
    $KONTEN [$data->kto_nr]-= $this->sql_1_value ("bu_belege","sum(b_betrag)",
                              "b_konto='$data->kto_nr' AND $BASIS");
  }
  // Umsatzsteuer ergeaenzen
  $KONTEN [$USTKto]+= $this->sql_1_value ("bu_belege","sum(b_steuer)",$BASIS);
  // Beitragsbuchungen ergaenzen
  $this->sql_befehl ("SELECT f_konto AS kto, sum(haben) AS beitrag FROM beitrag".
                     " WHERE v_name='$this->SET_VEREIN' AND jahr='$this->SET_JAHR'".
                     " GROUP BY f_konto");
  $i = 0; $FMax = $this->sql_lines(); while ($i < $FMax)
  {
    $data = $this->sql_line ($i); $i++;
    if (in_array($data->kto,array_keys($KONTEN)))
    { $KONTEN [$data->kto] += $data->beitrag; }
    else { $KONTEN [$data->kto] = $data->beitrag; }    
  }
  return ($KONTEN);
}

//****f* Tabelle: bu_belege +004+/sum_beitrag
// FUNCTION
//   sum_beitrag gezahlten Beitrag aus Beitragskonto holen 
// BEISPIEL
//   $SUMME = $Datenbank->sum_beitrag();
// ERGEBNIS
//   Es wird der gezahlte Beitrag zurueck gegeben
//****
public function sum_beitrag ()
{
  return($this->sql_1_value 
         ("beitrag","sum(haben)",
          "v_name='$this->SET_VEREIN' AND jahr='$this->SET_JAHR'"));
}

//****f* Tabelle: bu_belege +004+/sum_konto
// FUNCTION
//   sum_konto Summe fuer ein Konto
//     $nr      Konto-Nr.
//     $ziel    Zielkonto waehlen 
// ERGEBNIS
//   Die Summe der fuer das als $nr angegebene Konto wird zurueck ge-
//   geben. Wenn $ziel <> 0 handelt es sich um alle Buchungen fuer
//   das Zielkonto, ansonsten wird nur das angegebene Konto gewaehlt.
//****
public function sum_konto ($nr, $ziel = 0)
{
  $MERKER = $this->qu;
  // Standard-Einstellungen
  $BASIS = "b_verein='$this->SET_VEREIN' AND b_jahr='$this->SET_JAHR'";
  $OHNE_STEUER = ($this->get_kontenklasse($nr) == $this->get_vfinanz())
               ? 1 : 0;
  $OHNE_STEUER = ($this->get_kontenklasse($nr) == $this->get_vuebertrag())
               ? 1 : $OHNE_STEUER;
  if ($ziel == 0)  // Nur uebergebenes Konto beruecksichtigen
  {
    $RET = $this->sql_1_value ("bu_belege","sum(b_betrag)",
           "b_konto='$nr' AND $BASIS")
         - $this->sql_1_value ("bu_belege","sum(b_betrag)",
           "f_konto='$nr' AND $BASIS");
    if ($OHNE_STEUER == 0)
    {
      $RET += $this->sql_1_value ("bu_belege","sum(b_steuer)",
              "b_konto='$nr' AND $BASIS");
      $RET -= $this->sql_1_value ("bu_belege","sum(b_steuer)",
              "f_konto='$nr' AND $BASIS");
    } 
  }
  else // Auch die Konten beruecksichtigen, die auf $nr abgeschlossen werden
  {
    $this->sql_befehl ("SELECT * FROM bu_konten WHERE kto_ziel='$nr' AND ".
                       "verein='$this->SET_VEREIN' AND jahr='$this->SET_JAHR'");
    $RET = 0;
    $i = 0; while ($i < $this->sql_lines())
    {
      $data = $this->sql_line($i); $i++;
      $RET += $this->sql_1_value ("bu_belege","sum(b_betrag)",
              "b_konto='$data->kto_nr' AND $BASIS");
      $RET -= $this->sql_1_value ("bu_belege","sum(b_betrag)",
              "f_konto='$data->kto_nr' AND $BASIS");
      if ($OHNE_STEUER == 0)
      {
        $RET += $this->sql_1_value ("bu_belege","sum(b_steuer)",
                "b_konto='$data->kto_nr' AND $BASIS");
        $RET -= $this->sql_1_value ("bu_belege","sum(b_steuer)",
                "f_konto='$data->kto_nr' AND $BASIS");
      } 
    }     
  }
  $this->qu = $MERKER;
  return ($RET);
}

//****f* Tabelle: bu_belege +004+/find_beleg
// FUNCTION
//   find_beleg  Beleg suchen
//     $datum    Datum nach dem gesucht wird
//     $betrag   Buchungsbetrag
//     $inhalt   Buchungstext
// BEISPIEL
//   $Datenbank->find_beleg ("",0,"Testbeleg");
//   $i = 0; while ($i < $Datenbank->sql_lines ())  
//   { $data = $Datenbank->sql_line($i); echo $data->b_nr." ".$data->b_text; $i++; }
// ERGEBNIS
//   Datenbank wird entsprechend den uebergebenen Parametern durchsucht und
//   die gefundenen Belege koennen ueber die Datenbankabfragen abegeholt 
//   werden.
//****
public function find_beleg ($datum = "", $betrag = 0, $inhalt = "")
{
  $WHERE = "WHERE b_verein='$this->SET_VEREIN'";
  $WHERE .= ($datum == "") ? "" : " AND b_datum='$datum'";
  $WHERE .= ($betrag == 0) ? "" : " AND (b_betrag='$betrag' OR b_betrag='".($betrag * -1)."')";
  $WHERE .= ($inhalt == "") ? "" : " AND upper(b_text) LIKE upper('%$inhalt%')";
  $BEFEHL = "SELECT * FROM bu_belege $WHERE ORDER BY b_jahr,b_datum,b_text";
  $this->sql_befehl ($BEFEHL);
  $this->testlog ("find_beleg",$BEFEHL);
  return ($this->qu);
}

} // ENDE der Klasse

?>