<?php
//****h* Mitgliederverwaltung/mitglied.print.php
// BESCHREIBUNG
//   Daten zu einem Mitglied als PDF ausgeben
// AUTOR
//   Uwe Schied
// COPYRIGHT
//   GPL
// HISTORIE
//   11.03.2012 Start der Programmierung   
// BUGS
//   keine bekannt
//****
  include_once "base.inc";
  include_once "klassen/uvereinpdf.inc"; 

// ****************************************************************************
// Superglobals auslesen
// ****************************************************************************
  $NR = $FORM->returnglobal("NR",0);

// Dokument anlegen
  $PDF = new cl_uvereinpdf (i4l("txt_datenblatt"),$UVEREIN_DB->get_vereinsname());

function datenzeile ($a,$b)
{
	global $PDF;
	$PDF->table_line (array($a,$b));
}

// Personen-Daten
  $PDF->textzeile (i4l("TXT_PERSONENDATEN"),"",14,"L");
  $PDF->table_init (2,"Arial",10,0,array(1,5));
  datenzeile (i4l("DATA_ANREDE"),$UVEREIN_DB->sql_1_value("key_anrede","brief","schluessel='".
                                 $UVEREIN_DB->sql_1_value("personen","anrede","nr=$NR")."'"));
  datenzeile (i4l("DATA_NAME"),$UVEREIN_DB->sql_1_value("personen","titel","nr=$NR"));
  $PDF->TabColor = ($PDF->TabColor != 255) ? 255 : 240;
  datenzeile (" ",$UVEREIN_DB->sql_1_value("personen","vorname || ' ' || name","nr=$NR"));
  datenzeile (i4l("DATA_GEBOREN"),$UVEREIN_DB->sql_1_value("personen","geboren","nr=$NR"));
  datenzeile (i4l("TXT_ANSCHRIFT"),$UVEREIN_DB->sql_1_value("personen","strasse || ' ' || hausnr","nr=$NR"));
  $PDF->TabColor = ($PDF->TabColor != 255) ? 255 : 240;
  datenzeile ("",$UVEREIN_DB->sql_1_value("personen","plz || ' ' || ort","nr=$NR"));
  $PDF->TabColor = ($PDF->TabColor != 255) ? 255 : 240;
  datenzeile ("",$UVEREIN_DB->sql_1_value("personen","land","nr=$NR"));
  datenzeile (i4l("DATA_TELEFON"),$UVEREIN_DB->sql_1_value("personen","telefon","nr=$NR"));
  datenzeile (i4l("DATA_EMAIL"),$UVEREIN_DB->sql_1_value("personen","email","nr=$NR"));

// Mitgliedsdaten
  $PDF->textzeile ("","",10,"L");
  $PDF->Cell (0,1,"","B",2,"C",1);  
  $PDF->textzeile (i4l("TXT_MITGLIEDSDATEN"),"",14,"L");
  datenzeile (i4l("DATA_EINTRITT"),$UVEREIN_DB->sql_1_value("mitglied","eintritt","nr=$NR AND verein='$VEREIN_NAME'"));    
  datenzeile (i4l("DATA_ENDE"),$UVEREIN_DB->sql_1_value("mitglied","ende","nr=$NR AND verein='$VEREIN_NAME'"));
  datenzeile (i4l("DATA_KOMMENTAR"),$UVEREIN_DB->sql_1_value("mitglied","kommentar","nr=$NR AND verein='$VEREIN_NAME'"));

// Bankverbindung
  $PDF->textzeile ("","",10,"L");
  $PDF->Cell (0,1,"","B",2,"C",1);  
  $PDF->textzeile (i4l("TXT_BANKVERBINDUNG"),"",14,"L");
  datenzeile (i4l("sepa_mandantenid"),$NR);
  datenzeile (i4l("sepa_bic"),$UVEREIN_DB->sql_1_value("mitglied","bic","nr=$NR AND verein='$VEREIN_NAME'"));
  datenzeile (i4l("sepa_iban"),$UVEREIN_DB->sql_1_value("mitglied","iban","nr=$NR AND verein='$VEREIN_NAME'"));

// Zahlungsart
  $PDF->Cell (0,1,"","B",2,"C",1);  
  datenzeile (i4l("DATA_ZAHLUNGSART"),
              $UVEREIN_DB->sql_1_value("key_zahlungsarten","bezeichnung","nr='".
              $UVEREIN_DB->sql_1_value("mitglied","zahlungsart","nr=$NR AND verein='$VEREIN_NAME'")."'"));
  if ($UVEREIN_DB->sql_1_value("mitglied","zahlungsart","nr=$NR AND verein='$VEREIN_NAME'") == 1)
  {
    datenzeile ($UVEREIN_DB->sql_1_value("mitglied","unterschrift","nr=$NR AND verein='$VEREIN_NAME'"),"= ".i4l("sepa_unterschrift"));
  }
  
// Beitragsarten
  $PDF->textzeile ("","",10,"L");
  $PDF->Cell (0,1,"","B",2,"C",1);  
  $PDF->textzeile (i4l("TXT_BEITRAGSART"),"",14,"L");
  $PDF->table_init (3,"Arial",10,0,array(1,2,4));
  $PDF->table_head (array(i4l("TXT_FAELLIG_AB"),i4l("Z_TEXT"),i4l("TXT_BEITRAGSART")));
  $UVEREIN_DB->sql_befehl ("SELECT * FROM beitrags_konto".
                           "         WHERE v_name='$VEREIN_NAME' AND m_nr='$NR'".
                           "         ORDER BY faellig_ab");
  $i=0; while ($i < $UVEREIN_DB->sql_lines())
  {
  	$data = $UVEREIN_DB->sql_line($i); $i++;
  	$PDF->table_line (array($data->faellig_ab,
  	                        $UVEREIN_DB->sql_1_value("zahlungsweise","art","nr='$data->zahlungsweise'"),
  	                        $UVEREIN_DB->sql_1_value("beitrags_art","art","verein='$VEREIN_NAME' AND nr='$data->art'")));
  }
       
// --------------------------------------------------------
// PDF-Dokument auf Bildschirm ausgeben
// --------------------------------------------------------
$PDF->anzeige();
 
?>