<?php
//****h* Mitgliederverwaltung/mitglieder.transfer.php
// NAME
//   mitglieder.transfer.php
// BESCHREIBUNG
//   Feature-Request 3035877
//   Mitglieder als CSV-Datei einlesen und ausgeben
// ERGEBNIS
//
//   ohne Parameter:
//     Die Mitgliedsdaten werden in eine tab-getrennte Datei geschrieben
//     und die Datei zum Download angeboten.
//
//   IMPORT
//***

include_once "base.inc";
include_once "header.inc";
include_once "klassen/tabdatei.inc";

switch (strtoupper($AUSWAHL))
{
   case 'IMPORT': // Daten importierten
   $FORM->inhalt("<H2>".i4l("mitglieder_export")."</H2>");
   $FORM->inhalt("<B><U>".i4l("datenquelle")."</U></B><BR>");
   $FORM->selection ("AUSWAHL",array(
     "IMPORT_INTERN" => i4l("intern"),
     "IMPORT_EXTERN" => i4l("other")
   ));
   break;	

	default: // Daten exportieren
	$name = "../tmp/".date("U").".uverein";
	$DATEI = new cl_tabdatei($name,true);
	$qu = $UVEREIN_DB->sql_befehl ("SELECT * FROM mitglied WHERE verein='$VEREIN_NAME'");
	$i = 0; while ($i < $UVEREIN_DB->sql_lines($qu))
	{
		$data = $UVEREIN_DB->sql_line($i,$qu); 
		$i++;  
		$nr = $DATEI->A_nzahl;
		$e = 0; $WEITER = true; while ($WEITER)
		{
		  switch ($e)
		  {
		  	  case   0: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("data_eintritt"));
		  	            $wert = $data->eintritt; 
		  	            break;
		  	  case   1: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("data_ende")); 
		  	            $wert = $data->ende; 
		  	            break;
		  	  case   2: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("data_kommentar"));
 		  	            $wert = $data->kommentar; 
		  	            break;
		  	  case   3: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("data_zahlungsart"));
                     $wert = $data->zahlungsart; 
                     break;
		  	  case   4: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("sepa_bic"));
		  	            $wert = $data->bic;
		  	            break;
		  	  case   5: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("sepa_iban"));
		  	            $wert = $data->iban;
		  	            break;
		  	  case   6: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("data_anrede"));
		  	            $UVEREIN_DB->sql_befehl("SELECT * FROM personen WHERE nr='$data->nr'");
		  	            $data = $UVEREIN_DB->sql_line(0);
		  	            $wert = $data->anrede; 
		  	            break;
		  	  case   7: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("data_titel"));
		  	            $wert = $data->titel; 
		  	            break;
		  	  case   8: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("data_name"));
		  	            $wert = $data->name; 
		  	            break;
		  	  case   9: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("data_vorname"));
		  	            $wert = $data->vorname; 
		  	            break;
		  	  case  10: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("data_geboren"));
		  	            $wert = $data->geboren; 
		  	            break;
		  	  case  11: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("data_strasse"));
		  	            $wert = $data->strasse; 
		  	            break;
		  	  case  12: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("data_hausnr"));
		  	            $wert = $data->hausnr; 
		  	            break;
		  	  case  13: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("data_land"));
		  	            $wert = $data->land; 
		  	            break;
		  	  case  14: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("data_plz"));
		  	            $wert = $data->plz; 
		  	            break;
		  	  case  15: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("data_ort"));
		  	            $wert = $data->ort; 
		  	            break;
		  	  case  16: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("data_telefon"));
		  	            $wert = $data->telefon; 
		  	            break;
		  	  case  17: if ($i == 1) $DATEI->tab_set(-1,$e,i4l("data_email"));
		  	            $wert = $data->email; $WEITER = false; 
		  	            break;
		  	  case  18: $UVEREIN_DB->sql_befehl(
		  	               "SELECT * FROM beitrags_konto".
		  	               " WHERE v_name='$VEREIN_NAME'".
		  	               "   AND m_nr='$data->nr'");
		  	            $B_ANZ = $UVEREIN_DB->sql_lines();
		  	            $wert = $B_ANZ;
		  	            break;
		  	  default:  if ($B_ANZ > 0)
		  	            {
		  	            	$B_ANZ--;
		  	            	$data = $UVEREIN_DB->sql_line($B_ANZ);
		  	            	$DATEI->tab_set($nr,$e,$data->faellig_ab); $e++;
		  	            	$DATEI->tab_set($nr,$e,$data->art); $e++;
		  	            	$wert = $data->zahlungsweise;
		  	            } 
    	            	$WEITER = ($B_ANZ > 0) ? true : false;
		  	            break;
        }
        $DATEI->tab_set($nr,$e,$wert);
        $e++;
		}
   }
   $DATEI->tab_save();
// --------------------------------------------------------
// Zum Download auf dem Server bereitstellen
// --------------------------------------------------------
   header ("Content-Type: application/octet-stream");
   header ("Content-Disposition: attachment; filename=\"".
           $UVEREIN_DB->get_vereinsname().".tab\"");
   readfile ($name);   
   break;
}

if (in_array(strtoupper($AUSWAHL),array(
    "IMPORT",
    "IMPORT_INTERN"
))) {
  echo page_head ("");
  echo $FORM->schliessen();
  echo page_ende();
}
?>