<?php
//****h* Mitgliederverwaltung/print.beitrag.php
// BESCHREIBUNG
//   Aufstellung der Beitragsbuchungen als PDF-Dokument
// AUTOR
//   Uwe Schied
// COPYRIGHT
//   GPL
// HISTORIE
//   25.07.2009 Datum wird nicht angezeigt -> Problem behoben
// BUGS
//   keine bekannt
//**** 

include_once "base.inc";
include_once "klassen/uvereinpdf.inc";

$PDF  = new cl_uvereinpdf (i4l("MENU_TITLE_BEITRAG")." ".$AKT_YEAR,
                           $UVEREIN_DB->get_vereinsname()); 
$SEITENLAENGE = 260;
// --------------------------------------------------------
// Zahlendarstellung mit 2 Nachkommastellen
// --------------------------------------------------------
function zahl ($x)
{
  global $FORM;
  return ($FORM->numeingabe2anzeige($x,2));
}

// ---------------------------------------------------------
// Zwischensumme beim Seitenwechsel
// ---------------------------------------------------------
function neueseite ($art = "AUTO")
{
  global $ueberschrift, $SUMME, $PDF, $FORM, $SEITENLAENGE;
  if ($PDF->GetY() > $SEITENLAENGE)
  {
    $PDF->table_line("");
    $inhalt[0] = "";
    $inhalt[1] = "";
    $inhalt[2] = "";
    $inhalt[3] = zahl($SUMME);
    $inhalt[4] = "";
    $PDF->table_line($inhalt);
    if ($art == "AUTO")
    {
      $PDF->AddPage();
      $PDF->table_head ($ueberschrift);
      $PDF->table_line($inhalt);
      $PDF->table_line("");    
    }
  }
}

// --------------------------------------------------------
// PDF-Tabelle erstellen
// --------------------------------------------------------
$PDF->table_init (5,"Times",8,1,array(2,4,3,3,5),array("L","L","L","R","L"));
$ueberschrift[0] = i4l("data_datum");
$ueberschrift[1] = i4l("data_name");
$ueberschrift[2] = i4l("data_finanzkonto");
$ueberschrift[3] = i4l("DATA_BUCHUNGSBETRAG");
$ueberschrift[4] = i4l("data_buchungstext");
$PDF->table_head ($ueberschrift);

// --------------------------------------------------------
// Buchungen abfragen
// --------------------------------------------------------
$UVEREIN_DB->sql_befehl  ("SELECT * FROM beitrag".
                          " WHERE v_name='$VEREIN_NAME' AND jahr='$AKT_YEAR' AND haben<>'0'".
                          " ORDER BY datum, bu_nr");
// ---------------------------------------------------------
// Summe auf 0 setzen
// ---------------------------------------------------------
$SUMME = 0;
// ---------------------------------------------------------
// Belege in Tabelle eintragen
// ---------------------------------------------------------
$i = 0; while ($i < $UVEREIN_DB->sql_lines())
{
  // Datensatz holen
  $data = $UVEREIN_DB->sql_line($i); $i++;
  // Buchungs-Datum
  $inhalt[0] = $data->datum;
  // Mitgliedsname eintragen
  $inhalt[1] = $UVEREIN_DB->sql_1_value ("personen","name","nr='$data->m_nr'") . ", ".
               $UVEREIN_DB->sql_1_value ("personen","vorname","nr='$data->m_nr'"); 
  // Buchungskonto und Finanzkonto eintragen
  $inhalt[2] = $UVEREIN_DB->get_kontenname($data->f_konto);
  // Buchungsbetrag
  $inhalt[3] = zahl ($data->haben);
  // Buchungstext
  $inhalt[4] = $data->bu_text;
  // Daten in Tabellenzeile eintragen
  $PDF->table_line($inhalt);
  // Summe bilden
  $SUMME += $data->haben;
  // Neue Seite erforderlich ? Wenn ja, Uebertrag bilden
  neueseite();
}

// --------------------------------------------------------
// Schluss-Summe bilden
// --------------------------------------------------------
$SEITENLAENGE -= 50;
neueseite ("ENDE");
$PDF->table_line("");
$inhalt[0] = "*";
$inhalt[1] = "*";
$inhalt[2] = i4l("gesamt-summe");
$inhalt[3] = zahl($SUMME);
$inhalt[4] = " ";
$PDF->table_line($inhalt);

// --------------------------------------------------------
// PDF-Dokument auf Bildschirm ausgeben
// --------------------------------------------------------
$PDF->anzeige();

?>