<?php

//****h* php/print.belege-sum.php
// NAME
//  print.belege-sum.php
//  Erzeugt die Belegaufstellung als PDF - pro Buchungs-Nr. wird eine Zeile angedruckt
// HISTORIE
//  09.11.2008	Datei erstellt
//  24.01.2012 Nur bei Umbuchungen wird SOLL und HABEN in einer Zeile eingedruckt,
//             ansonsten wird SOLL und HABEN in einem Wert anzeigt
// GENUTZT VON
//  buchung.php  AUSWAHL=BELEGE

include_once "base.inc";
include_once "klassen/uvereinpdf.inc";

$PDF  = new cl_uvereinpdf (i4l("bu_belege")." ".$AKT_YEAR,$UVEREIN_DB->get_vereinsname());
// VOREINSTELLUNG
//   Seitenlaenge (bedruckbarer Bereich) wird auf 250 mm eingestellt
$SEITENLAENGE = 250;

// FUNCTION
//   zahl ($x)
//   Zahlendarstellung mit 2 Nachkommastellen
//     $x = auszuwertende Zahl
function zahl ($x) {
  global $FORM;
  return ($FORM->numeingabe2anzeige($x,2));
}

// FUNCTION
//   neueseite ($art)
//   Zwischensumme beim Seitenwechsel
//     $art = Art des Seitenwechsels
//            Moegliche Optionen:
//            * AUTO    = automatisch
function neueseite ($art = "AUTO") {
  global $ueberschrift, $SUMME, $PDF, $FORM, $SEITENLAENGE;
  if ($PDF->GetY() > $SEITENLAENGE) {
    $PDF->table_line("");
    $inhalt[0] = "";
    $inhalt[1] = "";
    $inhalt[2] = zahl($SUMME["SOLL"]);
    $inhalt[3] = zahl($SUMME["HABEN"]);
    $inhalt[4] = zahl($SUMME["STEUER"]);
    $inhalt[5] = "";
    $PDF->table_line($inhalt);
    if ($art == "AUTO") {
      $PDF->AddPage();
      $PDF->table_head ($ueberschrift);
      $PDF->table_line($inhalt);
      $PDF->table_line("");
    }
  }
}

// NOTES
// PDF-Tabelle erstellen
// --------------------------------------------------------
$PDF->table_init (6,"Times",8,1,array(2,2,3,3,3,6),array("C","L","R","R","R","L"));
$ueberschrift[0] = i4l("data_nr");
$ueberschrift[1] = i4l("data_datum");
$ueberschrift[2] = i4l("data_soll");
$ueberschrift[3] = i4l("data_haben");
$ueberschrift[4] = i4l("data_uststeuer");
$ueberschrift[5] = i4l("data_buchungstext");
$PDF->table_head ($ueberschrift);

// NOTES
// Besondere Informationen ermitteln
// --------------------------------------------------------
// Finanzkonten befinden sich in ?
$FART = $UVEREIN_DB->sql_1_value("virtual_konto","konto","art='FINANZKONTO' AND verein='$VEREIN_NAME'");
// Welches Konto enthaelt die verrechnete Vorsteuer ?
$VART = $UVEREIN_DB->sql_1_value("virtual_konto","fkonto","art='VORSTEUER' AND verein='$VEREIN_NAME'");

// NOTES
// Buchungen abfragen
// --------------------------------------------------------
$UVEREIN_DB->get_beleg ("","b_nr, b_datum");
// NOTES
// Summen auf 0 setzen
// ---------------------------------------------------------
$SUMME["SOLL"]   = 0;
$SUMME["HABEN"]  = 0;
$SUMME["STEUER"] = 0;
// NOTES
// Belege in Tabelle eintragen
// ---------------------------------------------------------
// 1. Durchgang = Betrag auf 0 setzen
$i = 0; while ($i < $UVEREIN_DB->sql_lines()) {
  // Datensatz holen
  $data = $UVEREIN_DB->sql_line($i); $i++;
  // Initialisieren
  $BUCHUNG[$data->b_nr]["SOLL"]   = 0;
  $BUCHUNG[$data->b_nr]["HABEN"]  = 0;
  $BUCHUNG[$data->b_nr]["STEUER"] = 0;
  $BUCHUNG[$data->b_nr]["DATUM"]  = "";
  $BUCHUNG[$data->b_nr]["TEXT"]   = "";
}
// 2. Durchgang = Betrag pro Buchungs-Nr. summieren
$i = 0; while ($i < $UVEREIN_DB->sql_lines()) {
  // Datensatz holen
  $data = $UVEREIN_DB->sql_line($i); $i++;
  // Buchung in Soll (-) oder Haben (+) eintragen
  $SOLL  = ($data->b_betrag < 0) ? -$data->b_betrag : 0;
  $HABEN = ($data->b_betrag < 0) ? 0 : $data->b_betrag;
  // Handelt es sich um eine Umbuchung innerhalb der Finanzkonten ?
  $KART =  ($UVEREIN_DB->get_kontenklasse($data->b_konto) == $FART) ? 1 : 0;
  $KART += ($UVEREIN_DB->get_kontenklasse($data->f_konto) == $FART) ? 1 : 0;
  // Soll und Haben gleich, wenn nur Umbuchung
  if ($KART <> 1) {
    $SOLL = $data->b_betrag * (($data->b_betrag < 0) ? -1 : 1);
    $HABEN = $SOLL;
  }
  // Betrag summieren
  $BUCHUNG[$data->b_nr]["SOLL"]   += $SOLL;
  $BUCHUNG[$data->b_nr]["HABEN"]  += $HABEN;
  $BUCHUNG[$data->b_nr]["STEUER"] += $data->b_steuer;
  // Nur bei Umbuchungen SOLL und HABEN anzeigen
  $SOLL = $BUCHUNG[$data->b_nr]["SOLL"];
  $HABEN = $BUCHUNG[$data->b_nr]["HABEN"];
  if ($SOLL <> $HABEN) {
  	 if ($SOLL > $HABEN) {$SOLL -= $HABEN; $HABEN = 0;} 
  	 else                {$HABEN -= $SOLL; $SOLL = 0;}
    $BUCHUNG[$data->b_nr]["SOLL"]   = $SOLL;
    $BUCHUNG[$data->b_nr]["HABEN"]  = $HABEN;
  }
  // Datum vermerken
  $OLD_DATUM = $BUCHUNG[$data->b_nr]["DATUM"];
  if ($OLD_DATUM == "") $NEW_DATUM = $data->b_datum;
  else $NEW_DATUM = ($OLD_DATUM == $data->b_datum) ? $OLD_DATUM : i4l("txt_mehrere");
  $BUCHUNG[$data->b_nr]["DATUM"] = $NEW_DATUM;
  // Buchungstext
  $OLD_TEXT = trim($BUCHUNG[$data->b_nr]["TEXT"]);
  $TESTWERT = strpos($OLD_TEXT, trim($data->b_text));
  $BUCHUNG[$data->b_nr]["TEXT"] .= ($TESTWERT === false) ? " " .$data->b_text : "";
  //$BUCHUNG[$data->b_nr]["TEXT"] .= ($OLD_TEXT == trim($data->b_text)) ? "" : " " .$data->b_text;
}

// NOTES
// Belege in PDF-Tabelle eintragen
// Nach Beleg-Nr. sortieren
ksort ($BUCHUNG);
foreach ($BUCHUNG as $bnr => $werte) {
  // Buchungs-Nr.
  $inhalt[0] = $bnr;
  // Buchungs-Datum
  $inhalt[1] = $werte["DATUM"];
  // Soll
  $inhalt[2] = ($werte["SOLL"] == 0) ? " " : zahl($werte["SOLL"]);
  // Haben
  $inhalt[3] = ($werte["HABEN"] == 0) ? " " : zahl($werte["HABEN"]);
  // Vorsteuer
  $inhalt[4] = ($werte["STEUER"] == 0) ? " " : zahl($werte["STEUER"]);
  // Buchungstext
  $werte["TEXT"] = trim($werte["TEXT"])." ";
  $inhalt[5] = substr($werte["TEXT"],0,120);
  $inhalt[5] .= ($inhalt[5] == $werte["TEXT"]) ? "" : "......";
  // Daten in Tabellenzeile eintragen
  $PDF->table_line($inhalt);
  // Summen bilden
  $SUMME["SOLL"]   += $werte["SOLL"];
  $SUMME["HABEN"]  += $werte["HABEN"];
  $SUMME["STEUER"] += $werte["STEUER"];
  // Neue Seite erforderlich ? Wenn ja, Uebertrag bilden
  neueseite();
}

// --------------------------------------------------------
// Beitragsbuchungen abfragen
// --------------------------------------------------------
$UVEREIN_DB->sql_befehl  ("SELECT f_konto,sum(haben) AS haben FROM beitrag".
                          " WHERE v_name='$VEREIN_NAME' AND jahr='$AKT_YEAR'".
                          " GROUP BY f_konto");
// ---------------------------------------------------------
// Beitrag in Tabelle eintragen
// ---------------------------------------------------------
// Buchungs-Nr.
$inhalt[0] = "*";
// Buchungs-Datum
$inhalt[1] = "";
// Vorsteuer
$inhalt[4] = "";
// Buchungstext
$inhalt[5] = i4l("beitrag");
$SOLL = 0; $HABEN = 0;
$i = 0; while ($i < $UVEREIN_DB->sql_lines()) {
  // Datensatz holen
  $data = $UVEREIN_DB->sql_line($i); $i++;
  if ($data->haben <> 0)  {
    // Buchung in Soll (-) oder Haben (+) eintragen
    $SOLL  += ($data->haben < 0) ? -$data->haben : 0;
    $HABEN += ($data->haben < 0) ? 0 : $data->haben;
  }
}
// Soll
$inhalt[2] = ($SOLL == 0) ? " " : zahl($SOLL);
// Haben
$inhalt[3] = ($HABEN == 0) ? " " : zahl($HABEN);
// Daten in Tabellenzeile eintragen
$PDF->table_line($inhalt);
// Summen bilden
$SUMME["SOLL"]   += $SOLL;
$SUMME["HABEN"]  += $HABEN;
// Neue Seite erforderlich ? Wenn ja, Uebertrag bilden
neueseite();

// --------------------------------------------------------
// Schluss-Summe bilden
// --------------------------------------------------------
$SEITENLAENGE -= 50;
neueseite ("ENDE");
$PDF->table_line("");
$inhalt[0] = "*";
$inhalt[1] = "*";
$inhalt[2] = ($SUMME["SOLL"]  > $SUMME["HABEN"]) ? zahl($SUMME["SOLL"] - $SUMME["HABEN"]) : "";
$inhalt[3] = ($SUMME["HABEN"] > $SUMME["SOLL"])  ? zahl($SUMME["HABEN"] - $SUMME["SOLL"]) : "";
$inhalt[4] = zahl($SUMME["STEUER"]);
$inhalt[5] = i4l("gesamt-summe");
$PDF->table_line($inhalt);

// --------------------------------------------------------
// Gewinn- und Verlustrechnung
// --------------------------------------------------------
$SOLL = $SUMME["HABEN"] - $SUMME["SOLL"] + $SUMME["STEUER"];
$inhalt[2] = ($SOLL < 0) ? zahl($SOLL * -1) : "";
$inhalt[3] = ($SOLL > 0) ? zahl($SOLL)      : "";
$inhalt[4] = "";
$inhalt[5] = i4l("bu_bilanz");
$PDF->table_line($inhalt);

// --------------------------------------------------------
// Vorsteuer beruecksichtigen
// --------------------------------------------------------
$SOLL = $UVEREIN_DB->sql_1_value("bu_belege","sum(b_betrag)",
         "b_konto='$VART' AND b_jahr='$AKT_YEAR' AND b_verein='$VEREIN_NAME'");
if ($SOLL <> 0)
{
  $inhalt[0] = "";
  $inhalt[1] = "";
  $inhalt[2] = "";
  $inhalt[3] = "";
  $inhalt[4] = zahl($SOLL);
  $inhalt[5] = i4l("abgerechnet");
  $PDF->table_line($inhalt);
  $SOLL = ($SUMME["STEUER"] - $SOLL);
  $inhalt[2] = ($SOLL < 0) ? zahl($SOLL * -1) : "";
  $inhalt[3] = ($SOLL > 0) ? zahl($SOLL)      : "";
  $inhalt[4] = "";
  $inhalt[5] = i4l("vorsteuer");
  $PDF->table_line($inhalt);
}
// --------------------------------------------------------
// PDF-Dokument auf Bildschirm ausgeben
// --------------------------------------------------------
$PDF->anzeige();

//****

?>