<?php

include_once "base.inc";
include_once "klassen/uvereinpdf.inc";

// --------------------------------------------------------
// Kostenstelle ermitteln
// --------------------------------------------------------
$KST  = $FORM->returnglobal("KST",0);
$K_ostenstelle = $UVEREIN_DB->sql_1_value("bu_kst","kst_name","verein='$VEREIN_NAME' AND kst='$KST'");

// --------------------------------------------------------
// Dokument erzeugen
// --------------------------------------------------------
$PDF  = new cl_uvereinpdf ($K_ostenstelle." (".$AKT_YEAR.")",$UVEREIN_DB->get_vereinsname ());

$SEITENLAENGE = 250;
// --------------------------------------------------------
// Zahlendarstellung mit 2 Nachkommastellen
// --------------------------------------------------------
function zahl ($x)
{
  global $FORM;
  return ($FORM->numeingabe2anzeige($x,2));
}

// ---------------------------------------------------------
// Zwischensumme beim Seitenwechsel
// ---------------------------------------------------------
function neueseite ($art = "AUTO")
{
  global $ueberschrift, $SUMME, $PDF, $FORM, $SEITENLAENGE;
  if ($PDF->GetY() > $SEITENLAENGE)
  {
    $PDF->table_line("");
    $inhalt[0] = "";
    $inhalt[1] = "";
    $inhalt[2] = zahl($SUMME["SOLL"]);
    $inhalt[3] = zahl($SUMME["HABEN"]);
    $inhalt[4] = zahl($SUMME["STEUER"]);
    $inhalt[5] = "";
    $PDF->table_line($inhalt);
    if ($art == "AUTO")
    {
      $PDF->AddPage();
      $PDF->table_head ($ueberschrift);
      $PDF->table_line($inhalt);
      $PDF->table_line("");
    }
  }
}

// --------------------------------------------------------
// PDF-Tabelle erstellen
// --------------------------------------------------------
$PDF->table_init (6,"Times",8,1,array(1,2,2,2,2,6),array("R","L","R","R","R","L"));
$ueberschrift[0] = i4l("data_nr");
$ueberschrift[1] = i4l("data_datum");
$ueberschrift[2] = i4l("data_soll");
$ueberschrift[3] = i4l("data_haben");
$ueberschrift[4] = i4l("data_uststeuer");
$ueberschrift[5] = i4l("data_buchungstext");
$PDF->table_head ($ueberschrift);

// --------------------------------------------------------
// Buchungen abfragen
// --------------------------------------------------------
$UVEREIN_DB->get_beleg ("b_kst='$KST'","b_datum,b_nr");
// ---------------------------------------------------------
// Summen auf 0 setzen
// ---------------------------------------------------------
$SUMME["SOLL"]   = 0;
$SUMME["HABEN"]  = 0;
$SUMME["STEUER"] = 0;
// ---------------------------------------------------------
// Kontenklassen merken
// ---------------------------------------------------------
$FART = $UVEREIN_DB->get_vfinanz();         // Finanzkonten
$VART = $UVEREIN_DB->get_vsteuer("FINANZ"); // Vorsteuer
// ---------------------------------------------------------
// Belege in Tabelle eintragen
// ---------------------------------------------------------
$i = 0; while ($i < $UVEREIN_DB->sql_lines())
{
  // Datensatz holen
  $data = $UVEREIN_DB->sql_line($i); $i++;
  // Buchung in Soll (-) oder Haben (+) eintragen
  $SOLL  = ($data->b_betrag < 0) ? -$data->b_betrag : "";
  $HABEN = ($data->b_betrag < 0) ? "" : $data->b_betrag;
  // Handelt es sich um eine Umbuchung innerhalb der Finanzkonten ?
  $KART = $UVEREIN_DB->get_kontenklasse($data->b_konto);
  // Soll und Haben gleich, wenn nur Umbuchung
  if ($KART == $FART)
  {
    if ($data->b_konto <> $VART)
    {
      $SOLL = $data->b_betrag * (($data->b_betrag < 0) ? -1 : 1);
      $HABEN = $SOLL;
    }
  }
  // Buchungs-Nr.
  $inhalt[0] = $data->b_nr;
  // Buchungs-Datum
  $inhalt[1] = $data->b_datum;
  // Soll
  $inhalt[2] = zahl($SOLL);
  // Haben
  $inhalt[3] = zahl($HABEN);
  // Vorsteuer
  $inhalt[4] = zahl($data->b_steuer);
  // Buchungstext
  $inhalt[5] = $data->b_text;
  // Daten in Tabellenzeile eintragen
  $PDF->table_line($inhalt);
  // Summen bilden
  $SUMME["SOLL"]   += $SOLL;
  $SUMME["HABEN"]  += $HABEN;
  $SUMME["STEUER"] += $data->b_steuer;
  // Neue Seite erforderlich ? Wenn ja, Uebertrag bilden
  neueseite();
}

// --------------------------------------------------------
// Schluss-Summe bilden
// --------------------------------------------------------
$SEITENLAENGE -= 50;
neueseite ("ENDE");
$PDF->textzeile (" ");
$inhalt[0] = "*";
$inhalt[1] = "*";
$inhalt[2] = zahl($SUMME["SOLL"]);
$inhalt[3] = zahl($SUMME["HABEN"]);
$inhalt[4] = zahl($SUMME["STEUER"]);
$inhalt[5] = "";
$PDF->table_line($inhalt);

$ERGEBNIS = $SUMME["HABEN"] - $SUMME["SOLL"] + $SUMME["STEUER"];
$inhalt[0] = "*";
$inhalt[1] = "*";
$inhalt[2] = ($ERGEBNIS >= 0) ? "" : zahl(($ERGEBNIS * -1));
$inhalt[3] = ($ERGEBNIS >= 0) ? zahl($ERGEBNIS) : "";
$inhalt[4] = " ";
$inhalt[5] = i4l("nettoergebnis");
$PDF->table_line($inhalt);


// --------------------------------------------------------
// PDF-Dokument auf Bildschirm ausgeben
// --------------------------------------------------------
$PDF->anzeige();

?>