<?php
//****h* Finanzbuchhaltung/sonder.php
// NAME
//   sonder.php
// BESCHREIBUNG
//   Sonderbuchungen erstellen und verwalten
// HISTORIE
//   19.02.2012 Datei angelegt
// BESTANDTEILE

include_once "base.inc";
include_once "header.inc";
include_once "klassen/tabdatei.inc"; 


//   TAB-Datei sonderdaten.0000.SONDERDATEIEN.tab
//   Übersicht über die Sonderdateien mit den Feldern:
$SONDERDATEIEN = new cl_tabdatei ("sonderdaten.0000.SONDERDATEIEN.tab");

$S_VEREIN        = 0; //   * Vereinsname
$S_JAHR          = 1; //   * Jahr
$S_NAME          = 2; //   * Name der Sonderdatei
$S_BEZEICHNUNG   = 3; //   * Bezeichnung der Sonderveranstaltung
$S_BUCHUNGSKONTO = 4; //   * Buchungskonto für die Verbuchung der Ein- und Ausgaben
$S_KOSTENSTELLE  = 5; //   * Kostenstelle
$S_EINDEUTIG     = 6; //   * Eindeutiges Ordnungsfeld

$FORM->inhalt(page_head ("u_verein &copy under GPL by Uwe Schied","Sonderbuchungen"));

switch (strtoupper ($AUSWAHL))
{
//
//   AUSWAHL=NEU
//   Neuanlage eines Sonderkonto's
	case 'NEU':
	  $FORM->inhalt ("<H1>".i4l("TXT_NEUANLAGE")."</H1>");
	  $FORM->hide("AUSWAHL","ERFASSEN");
	  $FORM->inhalt ("<TABLE>");

//   * Kurzbezeichnung des Sonder-Kontos (max. 30 Zeichen)
	  $FORM->inhalt ("<TR><TD><strong>".i4l("DATA_KURZBEZ")."</strong></TD><TD>");
	  $FORM->eingabe ("SONDER_NAME");
    $FORM->inhalt ("</TD></TR>");

//   * Bezeichnung des Sonderkontos (z.B. Spenden)
	  $FORM->inhalt ("<TR><TD><strong>".i4l("TXT_BEZEICHNUNG")."</strong></TD><TD>");
	  $FORM->eingabe ("SONDER_BEZEICHNUNG");
    $FORM->inhalt ("</TD></TR>");

//   * Buchungskonto für Einnahmen und Ausgaben
	  $FORM->inhalt ("<TR><TD><strong>".i4l("DATA_BUCHUNGSKONTO")."</strong></TD><TD>");
	  $FORM->selection ("SONDER_BUCHUNGSKONTO",$UVEREIN_DB->konten_liste4selection());
    $FORM->inhalt ("</TD></TR>");
    
//   * Kostenstelle für Einnahmen und Ausgaben
	  $FORM->inhalt ("<TR><TD><strong>".i4l("BU_KST")."</strong></TD><TD>");
	  $FORM->selection ("SONDER_KOSTENSTELLE",
	         $UVEREIN_DB->liste4selection("bu_kst","verein='$VEREIN_NAME'","kst","kst_name"));
    $FORM->inhalt ("</TD></TR>");

    $FORM->inhalt ("<TR><TD>&nbsp;</TD><TD>");
	  $FORM->grafikbutton ("OK","../icons/ok.png",false);
	  $FORM->inhalt ("</TD></TR>");

	  $FORM->fokus ("SONDER_BEZEICHNUNG"); 
	  $FORM->inhalt ("</TABLE>"); 
  break;
//
//   AUSWAHL=ERFASSEN
//   Sonderkonto neu anlegen oder Änderung erfassen
  case 'ERFASSEN':
    $X_NAME = strtoupper(str_replace (" ","_",$FORM->returnwert("SONDER_NAME")));
    $X_EINDEUTIG = "$VEREIN_NAME.$AKT_YEAR.$X_NAME";
    $SONDERDATEIEN->tab_set_by_search($S_EINDEUTIG,$X_EINDEUTIG,$S_EINDEUTIG,$X_EINDEUTIG);
    $SONDERDATEIEN->tab_set_by_search($S_EINDEUTIG,$X_EINDEUTIG,$S_VEREIN,$VEREIN_NAME);
    $SONDERDATEIEN->tab_set_by_search($S_EINDEUTIG,$X_EINDEUTIG,$S_JAHR,$AKT_YEAR);
    $SONDERDATEIEN->tab_set_by_search($S_EINDEUTIG,$X_EINDEUTIG,$S_NAME,$X_NAME);
    $SONDERDATEIEN->tab_set_by_search($S_EINDEUTIG,$X_EINDEUTIG,$S_BEZEICHNUNG,
                                      $FORM->returnwert("SONDER_BEZEICHNUNG"));
    $SONDERDATEIEN->tab_set_by_search($S_EINDEUTIG,$X_EINDEUTIG,$S_BUCHUNGSKONTO,
                                      $FORM->returnwert("SONDER_BUCHUNGSKONTO"));
    $SONDERDATEIEN->tab_set_by_search($S_EINDEUTIG,$X_EINDEUTIG,$S_KOSTENSTELLE,
                                      $FORM->returnwert("SONDER_KOSTENSTELLE"));
    $SONDERDATEIEN->tab_sort();
    $SONDERDATEIEN->tab_save();
  break;
//
//   AUSWAHL=alle anderen Werte
//   Daten in Sonderkonto bearbeiten
  default:
    $X_EINDEUTIG = $FORM->returnwert("SONDER_EINDEUTIG");
  break;
}

if ($AUSWAHL != "NEU")
{
	$FORM->hide ("AUSWAHL","CHANGE");
	$FORM->hide ("SONDER_EINDEUTIG",$X_EINDEUTIG);
	$FORM->inhalt ("<H2>".$SONDERDATEIEN->tab_get($S_EINDEUTIG,$X_EINDEUTIG,$S_BEZEICHNUNG)."</H2>");
	$FORM->inhalt ("<TABLE border=\"1\" width=\"95%\" >");
	$FORM->inhalt ("<TR>");
//   TAB-Datei sonderdaten.XXXXXX.tab
//   Sonderdatei mit Buchungsdaten 
  $SONDERDATEN = new cl_tabdatei ("sonderdaten.$X_EINDEUTIG.tab");
  $SD_NAME        = 0; //   * Name
  $SD_HINWEIS     = 1; //   * Informationen
  $SD_SOLL        = 2; //   * Soll-Betrag
  $SD_NR          = 3; //   * Buchungs-Nr.
  
// Daten anzeigen
// Name   Hinweise  Soll-Betrag   Zahlung
//                                Buchungs-Nr.  Datum  Betrag
  $FORM->inhalt ("<td width=\"5%\" rowspan=\"2\">&nbsp;</TD>");
  $FORM->inhalt ("<td width=\"20%\" rowspan=\"2\"><strong>".i4l("DATA_NAME")."</strong></TD>");
  $FORM->inhalt ("<TD width=\"35%\" rowspan=\"2\"><strong>".i4l("BESCHREIBUNG")."</strong></TD>");
  $FORM->inhalt ("<TD width=\"10%\" rowspan=\"2\"><strong>".i4l("DATA_SOLL")."</strong></TD>");
  $FORM->inhalt ("<TD colspan=\"3\"><strong>".i4l("MENU_SONDER")."</strong></TD>");
  $FORM->inhalt ("</TR><TR>");
  $FORM->inhalt ("<TD width=\"5%\"><strong>".i4l("TXT_BELEGNR")."</strong></TD>");
  $FORM->inhalt ("<TD width=\"15%\"><strong>".i4l("DATA_DATUM")."</strong></TD>");
  $FORM->inhalt ("<TD width=\"10%\"><strong>".i4l("DATA_HABEN")."</strong></TD>");
  $FORM->inhalt ("</TR>");
  $i = 0; while ($i < $SONDERDATEN->A_nzahl)
  {
  	$FORM->inhalt ("<TR>");
  	$FORM->inhalt ("<TD>"."</TD>");
  	$FORM->inhalt ("<TD>".$SONDERDATEN->tab_by_nr($i,$SD_NAME)."</TD>");
  	$FORM->inhalt ("<TD>".$SONDERDATEN->tab_by_nr($i,$SD_HINWEIS)."</TD>");
  	$FORM->inhalt ("<TD>".$SONDERDATEN->tab_by_nr($i,$SD_SOLL)."</TD>");
  	$NR = $SONDERDATEN->tab_by_nr($i,$SD_NR);
  	$FORM->inhalt ("<TD>$NR</TD>");
  	$UVEREIN_DB->get_beleg ("b_nr='$NR'","b_datum"); $data = $UVEREIN_DB->sql_line(0);
  	$FORM->inhalt ("<TD>".$data->b_datum."</TD>");
  	$FORM->inhalt ("<TD>".$data->b_betrag."</TD>");
  	$FORM->inhalt ("</TR>");
  	$i++;
  }
	$FORM->inhalt ("<TR>");
 	$FORM->inhalt ("<TD>"); $FORM->grafikbutton ("NEU","../icons/new.png",false); $FORM->inhalt ("</TD>");
 	$FORM->inhalt ("<TD>"); $FORM->eingabe ("SD_NAME",50); $FORM->inhalt ("</TD>");
 	$FORM->inhalt ("<TD>"); $FORM->eingabe ("SD_HINWEIS",50); $FORM->inhalt ("</TD>");
 	$FORM->inhalt ("<TD>"); $FORM->eingabe ("SD_SOLL",15); $FORM->inhalt ("</TD>");
 	$FORM->inhalt ("<TD>"); $FORM->eingabe ("SD_NR",10); $FORM->inhalt ("</TD>");
 	$FORM->inhalt ("<TD colspan=\"2\">&nbsp;</TD>");
 	$FORM->inhalt ("</TR>");
	$FORM->inhalt ("</TABLE>");
}

$FORM->inhalt(page_ende ()); echo $FORM->schliessen();

echo $FORM->test();

//****
?>