<?php
//****h* Vereine verwalten/verein-basis.php
// BESCHREIBUNG
//   Vereinsdaten verwalten (SEPA-Version)
// BUGS
//   keine bekannt
// COPYRIGHT
//   GPL
// AUTOR
//   Uwe Schied
// BESCHREIBUNG
//   Der Aufruf erfolgt über das Vereins-Menü - folgende Parameter
//   sind definiert:
//   * NEU              Neuanlage eines Vereins
//   * NEU_ERFASSEN     Daten für die Neuanlage in Datenbank eintragen
// HISTORIE
//   25.12.2013 Start - Neuen Verein erfassen
//              Neuanlage fertig gestellt
//****

include_once "base.inc";
include_once "header.inc";


register_help_pos ("VEREIN_BASIS");
$FORM->inhalt (page_head ("u_verein &copy under GPL by Uwe Schied"));

// Formular-Überschrift
$FORM->inhalt ("<H1>");
switch ($AUSWAHL)
{
  // Neuanlage
	case 'NEU' : 
	  $FORM->inhalt(i4l("MENU_VEREIN_NEW")); break;
  // Neuen Verein erfassen	
	case 'NEU_ERFASSEN' :
    // eindeutigen Namen festlegen
	  $kurzname = psql_tablename("v".trim(strtolower(date("y_YzHis"))));
	  $FORM->inhalt(i4l("MENU_VEREIN_update"). " >> ".trim($FORM->returnwert("NAME"))." <<");
	  // in 'vereine' eintragen 
	  $UVEREIN_DB->sql_befehl("INSERT INTO vereine (name,kurzname,strasse,ort,bic,iban,identnr,email)".
	                          " VALUES ('".trim($FORM->returnwert("NAME"))."','$kurzname',".
                                     "'".trim($FORM->returnwert("STRASSE"))."',".
                                     "'".trim($FORM->returnwert("ORT"))."',".
                                     "'".strtoupper(trim($FORM->returnwert("BIC")))."',".
                                     "'".strtoupper(trim($FORM->returnwert("IBAN")))."',".
                                     "'".strtoupper(trim($FORM->returnwert("IDENTNR")))."',".
                                     "'".trim($FORM->returnwert("MAIL"))."')");
    // Neuen Verein in User-Recht aufnehmen
    include_once "klassen/tabdatei.inc";
    $USER_DB = new cl_tabdatei ("../include/uverein.paswd");
    $USER_NAME  = $_SESSION['UVEREIN_LOGIN_NAME'];
    $USER_RECHT = $_SESSION['UVEREIN_LOGIN_RECHTE'];
    $USER_RECHT .= ( $USER_RECHT == "*" )
                ? ""                      // wenn Admin, dann nichts erforderlich
		            : "," . $kurzname;        // ansonsten neuen Verein ergaenzen
    $USER_DB->tab_set_by_search (0,$USER_NAME,2,$USER_RECHT);
    $USER_DB->tab_save();
    $_SESSION['UVEREIN_LOGIN_RECHTE'] = $USER_RECHT;
    $AUSWAHL = "EDIT";
    $UVEREIN_DB->set_verein($kurzname);
    $VEREIN_NAME = $kurzname;
    $FORM->hide ("VEREIN_CHANGED","YES");
    $FORM->hide ("SET_VEREIN",$kurzname);
	  break;
  // Daten ändern
	case 'EDIT' : 
	  $FORM->inhalt(i4l("MENU_VEREIN_update")); break;
  // Änderung erfassen
  case 'EDIT_ERFASSEN':
    $FORM->inhalt(i4l("MENU_VEREIN_update")); 
  	$kurzname = $UVEREIN_DB->get_vereinsname();
	  $UVEREIN_DB->sql_befehl("UPDATE vereine SET name='".trim($FORM->returnwert("NAME"))."'".
	                                           ", strasse='".trim($FORM->returnwert("STRASSE"))."'".
	                                           ", ort='".trim($FORM->returnwert("ORT"))."'".
	                                           ", bic='".strtoupper(trim($FORM->returnwert("BIC")))."'".
	                                           ", iban='".strtoupper(trim($FORM->returnwert("IBAN")))."'".
	                                           ", identnr='".strtoupper(trim($FORM->returnwert("IDENTNR")))."'".
	                                           ", email='".trim($FORM->returnwert("MAIL"))."'".
	                          " WHERE kurzname='$VEREIN_NAME'"); 
  	break;   	
}
$FORM->inhalt("</H1><TABLE>");

// Prüfen ob Neuanlage oder Änderung erfolgen soll
if ($AUSWAHL == "NEU") 
{
	$FORM->setwert ("NAME","");
	$FORM->setwert ("STRASSE","");
  $FORM->setwert ("ORT","");
  $FORM->setwert ("BIC","");
  $FORM->setwert ("IBAN","");
  $FORM->setwert ("IDENTNR","");
  $FORM->setwert ("MAIL","");
  $FORM->hide ("AUSWAHL","NEU_ERFASSEN");
}
else 
{
	$FORM->setwert ("NAME",$UVEREIN_DB->get_vereinsname());
	$FORM->setwert ("STRASSE",$UVEREIN_DB->sql_1_value ("vereine","strasse","kurzname='$VEREIN_NAME'"));
	$FORM->setwert ("ORT",$UVEREIN_DB->sql_1_value ("vereine","ort","kurzname='$VEREIN_NAME'"));
	$FORM->setwert ("BIC",$UVEREIN_DB->sql_1_value ("vereine","bic","kurzname='$VEREIN_NAME'"));
	$FORM->setwert ("IBAN",$UVEREIN_DB->sql_1_value ("vereine","iban","kurzname='$VEREIN_NAME'"));
	$FORM->setwert ("IDENTNR",$UVEREIN_DB->sql_1_value ("vereine","identnr","kurzname='$VEREIN_NAME'"));
	$FORM->setwert ("MAIL",$UVEREIN_DB->sql_1_value ("vereine","email","kurzname='$VEREIN_NAME'"));
	$FORM->hide ("AUSWAHL","EDIT_ERFASSEN");
}

// Formular zur Eingabe aufrufen
function vereinbasis_eingabe ($anzeige,$feld,$laenge)
{
	global $FORM;
	$FORM->inhalt ("<TR><TD>$anzeige</TD><TD>");
	$FORM->eingabe ($feld,$laenge);
	$FORM->inhalt ("</TD></TR>");
}
$FORM->inhalt("<TABLE>");
vereinbasis_eingabe (i4l("data_vereinsname"),"NAME",100);
$FORM->inhalt("<TR><TD>&nbsp;</TD><TD><HR></TD></TR>");
vereinbasis_eingabe (i4l("data_strasse"),    "STRASSE",80);
vereinbasis_eingabe (i4l("data_plz")." ".i4l("data_ort"),"ORT",120);
$FORM->inhalt("<TR><TD>&nbsp;</TD><TD><HR></TD></TR>");
vereinbasis_eingabe (i4l("SEPA_BIC"),"BIC",50);
vereinbasis_eingabe (i4l("sepa_iban"),"IBAN",50);
vereinbasis_eingabe (i4l("sepa_identnr"),"IDENTNR",50);
$FORM->inhalt("<TR><TD>&nbsp;</TD><TD><HR></TD></TR>");
vereinbasis_eingabe (i4l("data_email"),"MAIL",120);

// Formular-Ende
$FORM->inhalt("</TABLE><DIV align=\"left\"");
$FORM->grafikbutton (i4l("msg_erfassen"),"../icons/ok.png",false);
$FORM->inhalt("</DIV>");
$FORM->inhalt(page_ende ());
echo $FORM->schliessen();
?>