--****U* Installation/update_1232630993.sql
-- BESCHREIBUNG
--   Jahr in bu_konten eintragen
--
--   Neue Definition nach der Aenderung:
--   TABLE bu_konten (
--     verein         VARCHAR(20)   NOT NULL REFERENCES vereine (kurzname),
--     kto_nr         NUMERIC(10,0) NOT NULL,
--     kto_name       TEXT          NOT NULL,
--     kto_klasse     NUMERIC(10,0) NOT NULL,
--     kto_ziel       NUMERIC(10,0) NOT NULL,
--     kto_stand      NUMERIC(25,2),
--     jahr           VARCHAR(10)   NOT NULL DEFAULT EXTRACT(YEAR FROM CURRENT_DATE)
--  )
-- HISTORIE
--   22.01.2009  0.2.3-1 erstellt
--****

-- Jahr in Konten-Tabelle einfuegen
ALTER TABLE bu_konten ADD jahr VARCHAR (10);

-- aktuelles Jahr eintragen
UPDATE bu_konten SET jahr='1232630993';

-- Default-Wert setzen
ALTER TABLE bu_konten ALTER COLUMN jahr SET DEFAULT EXTRACT(YEAR FROM CURRENT_DATE);
ALTER TABLE bu_konten ALTER COLUMN jahr SET NOT NULL;

-- Index anpassen
DROP          INDEX idx_bu_konten;
CREATE UNIQUE INDEX idx_bu_konten ON bu_konten (verein,jahr,kto_nr);
